/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-07  Modified: 2016-10-01	//
//																																	//
// SWOT_App.cpp : Implementation of the 'SWOT_App' class and functions.										//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SWOT_App.h"
#include "SetWndOnTop.h"
#include "SWOT_DlgSetWndOnTop.h"
#include <locale.h>
#include <fcntl.h>
#include <shlwapi.h>
#include <shlobj.h>
#include "dwmapi.h"
#include <mmsystem.h>
#include "SWOT_Global.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////

SWOT_App	  *SWOT_App::m_pGlobal = 0;

#ifdef _DEBUG
int			SWOT_App::m_nObjectCount = 0;
#endif

/////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-07  Modified: 2016-10-01	//
//																																	//
//	Purpose:	Definition of the constructor.																			//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

SWOT_App::SWOT_App()
{
//	ASSERT( (new char [16]) != 0 );	//	Force the generation of a memory leak to see if detection is working.  Detection seems to fail with "Use MFC in a Shared DLL".

	ASSERT( m_nObjectCount++ == 0 );	// Warn if more than one object is created in the application.
	m_pGlobal = this;

	_tcsEmpty( m_szCurrentDirAtStart );
	_tcsEmpty( m_szModuleFileName );

	//------------------------------------------------

	m_hInstance  = 0;
	m_pszCmdLine = 0;
	m_nCmdShow	 = 0;
	m_nExitValue = aevNoError;

	m_un64AppFileVersion = 0;
	m_un64ProductVersion	= 0;

	m_bIsOleInitialized = FALSE;

	m_hMemFont_SegoeUI_TTF = 0;

	//------------------------------------------------

	// Load the DLL and keep the handle to it.  No matter if the function succeeds or not.
	// Must load dynamicaly because this DLL exists only in Vista and more recent OS.  (Does not exist in XP.)

	if ( (m_hDwmApiDll = ::LoadLibrary( _T("dwmapi.dll") )) != 0 )
	{
		m_pfnDwmIsCompositionEnabled = (PFN_DwmIsCompositionEnabled)::GetProcAddress( m_hDwmApiDll, "DwmIsCompositionEnabled" );
		m_pfnDwmGetWindowAttribute	  = (PFN_DwmGetWindowAttribute  )::GetProcAddress( m_hDwmApiDll, "DwmGetWindowAttribute"   );
	}
	else
	{
		m_pfnDwmIsCompositionEnabled = 0;
		m_pfnDwmGetWindowAttribute	  = 0;
	}
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-07  Modified: 2016-07-07	//
//																																	//
//	Purpose:	Definition of the destructor.																				//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

SWOT_App::~SWOT_App()
{
	ASSERT( --m_nObjectCount == 0 );	// Warn if more than one object is created in the application.

//---------------------------------------------------------------------------------------------------

	//	The following line will only call the SWOT_App::Cleanup() function because once we are here in
	//	 this destructor, that means there is no more any derived class accessible.  So if you want
	//	 your derived virtual Cleanup() function to be called, you have to call it yourself from your
	//	 derived class desctructor function.
	SWOT_App::Cleanup();

//---------------------------------------------------------------------------------------------------

	m_pGlobal = 0;
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-07  Modified: 2016-09-15	//
//																																	//
//	Purpose:																														//
//																																	//
//	Result: Returns TRUE if successful.  Otherwise returns FALSE.												//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

//	BE VERY CAREFUL WITH THE INITIALIZATION ORDER.

bool SWOT_App::Initialize( HINSTANCE hInstanceApp, LPTSTR pszCmdLine, int nCmdShow )
{
	DWORD		dwRtnVal;
	HRESULT	nResult;
	TCHAR		szCurrentDirAtStart_Tmp[MAX_PATH];
	CString	strTitleErrInit, strTextErrCodeFmtMsg, strTextErrCode, strText;

//---------------------------------------------------------------------------------------------------

	FOREVER
	{
		m_nExitValue			= aevNoError;
		strTitleErrInit		= SWOT_Txt_TitleErrorInit;
		strTextErrCodeFmtMsg = SWOT_FmtMsg_ErrorCodeHeader;

//---------------------------------------------------------------------------------------------------
//	Set miscellaneous variables and stuff.

		if ( (hInstanceApp == 0) || (pszCmdLine == 0) )
		{
			m_nExitValue = aevError_BadArguments;
			break;	//	Exits the forever loop.
		}
																		  
		//------------------------------------------------

		m_hInstance	 = hInstanceApp;
		m_pszCmdLine = pszCmdLine;
		m_nCmdShow	 = nCmdShow;

		_set_fmode( _O_BINARY );	// Required if you do not link with "binmode.obj".

//		_tsetlocale( LC_ALL, _T("") );		//	This line conflicts with Dekko3d hardcoded decimal point character.		/*2beRemoved*/
		_tsetlocale( LC_CTYPE, _T("") );		//	Set the locale LC_CTYPE and LC_COLLATE to the default, which is the
		_tsetlocale( LC_COLLATE, _T("") );	//	 user-default ANSI code page obtained from the operating system.

		AfxSetResourceHandle( m_hInstance );

//---------------------------------------------------------------------------------------------------

		if ( ((dwRtnVal = ::GetModuleFileName( m_hInstance, m_szModuleFileName, _countof( m_szModuleFileName ) )) > 0) &&
				(dwRtnVal < _countof( m_szModuleFileName )) )
		{
			if ( !SWOT_SHGetVersionNumbers( m_szModuleFileName, &m_un64AppFileVersion, 0, &m_un64ProductVersion ) )
			{
				m_nExitValue = aevError_ApplicationVersion;
			}
		}
		else m_nExitValue = aevError_ModuleFileName;

		//------------------------------------------------

		if ( (m_nExitValue == aevError_ModuleFileName) || (m_nExitValue == aevError_ApplicationVersion) )
		{
			strTextErrCode.FormatMessage( strTextErrCodeFmtMsg, m_nExitValue );
			strText.FormatMessage( SWOT_FmtMsg_GetAppNameVersionFailed, (LPCTSTR)strTextErrCode, m_szModuleFileName,
										  SWOT_SHGetVersionMajor( m_un64AppFileVersion ), SWOT_SHGetVersionMinor( m_un64AppFileVersion ),
										  SWOT_SHGetVersionBuild( m_un64AppFileVersion ), SWOT_SHGetVersionRevision( m_un64AppFileVersion ) );
			::MessageBox( 0, strText, strTitleErrInit, (MB_ICONERROR | MB_OK) );
			break;	//	Exits the forever loop.
		}

//---------------------------------------------------------------------------------------------------
//	Initializes the application key name used to access miscellaneous variables in the Registry.

		m_strRegKey__AppKeyName.Format( SWOT_REG_KEY__ADELUC_SWOTn, (unsigned int)SWOT_SHGetVersionMajor( m_un64AppFileVersion ) );

//---------------------------------------------------------------------------------------------------
//	Set 'm_szCurrentDirAtStart'.  For explanations about 'GetFullPathName()' see the remarks section in 'GetCurrentDirectory()'.

		if ( ((dwRtnVal = ::GetCurrentDirectory( _countof( szCurrentDirAtStart_Tmp ), szCurrentDirAtStart_Tmp )) == 0) ||
				(dwRtnVal >= _countof( szCurrentDirAtStart_Tmp )) )
		{
			m_nExitValue = aevError_CurrentDirectory;
		}
		else	//	First part successful.
		{
			if ( ((dwRtnVal = ::GetFullPathName( szCurrentDirAtStart_Tmp, _countof( m_szCurrentDirAtStart ), m_szCurrentDirAtStart, NULL )) == 0) ||
					(dwRtnVal >= _countof( m_szCurrentDirAtStart )) )
			{
				m_nExitValue = aevError_CurrentDirectory;
			}
		}

		//------------------------------------------------

		if ( m_nExitValue == aevError_CurrentDirectory )
		{
			strTextErrCode.FormatMessage( strTextErrCodeFmtMsg, m_nExitValue );
			strText.FormatMessage( SWOT_FmtMsg_GetCurrentDirFailed, (LPCTSTR)strTextErrCode );
			::MessageBox( 0, strText, strTitleErrInit, (MB_ICONERROR | MB_OK) );
			break;	//	Exits the forever loop.
		}

//---------------------------------------------------------------------------------------------------
//	Call to 'OleInitialize()'.

		nResult = ::OleInitialize( NULL );		// Initialize the COM library.

		if ( (nResult == S_OK) || (nResult == S_FALSE) )
		{
			m_bIsOleInitialized = TRUE;
		}
		else
		{
			if ( nResult == OLE_E_WRONGCOMPOBJ ) m_nExitValue = aevError_OleInitWrongCompObj;
			else											 m_nExitValue = aevError_OleInitialize;

			strTextErrCode.FormatMessage( strTextErrCodeFmtMsg, m_nExitValue );
			strText.FormatMessage( ((m_nExitValue == aevError_OleInitialize) ? SWOT_FmtMsg_OleInitializeFailed :
											SWOT_FmtMsg_OleInitializeWrongCompObj), (LPCTSTR)strTextErrCode );
			::MessageBox( 0, strText, strTitleErrInit, (MB_ICONERROR | MB_OK) );
			break;	//	Exits the forever loop.
		}

//---------------------------------------------------------------------------------------------------
//	Opens our private fonts.

		if ( !InstallPrivateFonts() )
		{
			strTextErrCode.FormatMessage( strTextErrCodeFmtMsg, (m_nExitValue = aevError_InstallPrivateFonts) );
			strText.FormatMessage( SWOT_FmtMsg_InstallPrivateFontsFailed, (LPCTSTR)strTextErrCode );
			::MessageBox( 0, strText, strTitleErrInit, (MB_ICONERROR | MB_OK) );
			break;	//	Exits the forever loop.
		}

//---------------------------------------------------------------------------------------------------

		break;	//	Exits the forever loop.
	}

//---------------------------------------------------------------------------------------------------

	return( (m_nExitValue == aevNoError) );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-07  Modified: 2016-09-15	//
//																																	//
//	Purpose:																														//
//																																	//
// IMPORTANT: This function may be called more than once.  It may be called from anywhere and also	//
//				  automatically by ~SWOT_App().  So make the function safe to not free stuff twice.		//
//				  Keep in mind that this function will be called even if Initialize() has failed.		//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

void SWOT_App::Cleanup()
{
	UninstallPrivateFonts();

	//------------------------------------------------

	if ( m_bIsOleInitialized )
	{
		::CoUninitialize();
		m_bIsOleInitialized = FALSE;
	}

	//------------------------------------------------

	if ( m_hDwmApiDll != 0 )
	{
		m_pfnDwmIsCompositionEnabled = 0;
		m_pfnDwmGetWindowAttribute	  = 0;

		::FreeLibrary( m_hDwmApiDll );
		m_hDwmApiDll = 0;
	}

	//------------------------------------------------

	if ( !_tcsIsEmpty( m_szCurrentDirAtStart ) )
	{
		TCHAR		szCurrentDirectoryAtStart[MAX_PATH];

		_tcscpy_s( szCurrentDirectoryAtStart, m_szCurrentDirAtStart );
		::PathRemoveBackslash( szCurrentDirectoryAtStart );	// Just in case.
		::SetCurrentDirectory( szCurrentDirectoryAtStart );	// Restores the starting directory.
		_tcsEmpty( m_szCurrentDirAtStart );							//	Prevents this block of code to be done again.
	}
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-07  Modified: 2016-07-07	//
//																																	//
//	Purpose:	Installs all the fonts located in the resource.														//
//																																	//
//	Result: Returns TRUE if successful.  Otherwise returns FALSE.												//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

bool SWOT_App::InstallPrivateFonts()
{
	bool		bStatus = TRUE;
	HRSRC		hrsrcTDST;
	DWORD		dwResSize, dwFontsInstalledCount;
	HGLOBAL	hglobalFONT;
	PVOID		pvData;

//---------------------------------------------------------------------------------------------------

	if ( bStatus && ((hrsrcTDST = FindResource( m_hInstance, SWOT_FONT_FILE_SEGOEUI_TTF, _T("PRIVATE_FONT") )) != 0) &&
			((dwResSize = SizeofResource( m_hInstance, hrsrcTDST )) != 0) )
	{
		if ( (hglobalFONT = LoadResource( m_hInstance, hrsrcTDST )) != 0 )
		{
			if ( (pvData = LockResource( hglobalFONT )) != 0 )
			{
				if ( (m_hMemFont_SegoeUI_TTF = AddFontMemResourceEx( pvData, dwResSize, 0, &dwFontsInstalledCount)) == 0 ) bStatus = FALSE;

				UnlockResource( hglobalFONT );
				pvData = 0;
			}		
		
			FreeResource( hglobalFONT );
			hglobalFONT = 0;
		}		
	}		

//---------------------------------------------------------------------------------------------------

	if ( !bStatus )
	{
		UninstallPrivateFonts();
	}

//---------------------------------------------------------------------------------------------------

	return( bStatus );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-07  Modified: 2016-07-07	//
//																																	//
//	Purpose: Closes all the font files previously opened by InstallPrivateFonts().						//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

void SWOT_App::UninstallPrivateFonts()
{
	if ( m_hMemFont_SegoeUI_TTF != 0 )
	{
		RemoveFontMemResourceEx( m_hMemFont_SegoeUI_TTF );
		m_hMemFont_SegoeUI_TTF = 0;
	}
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-07  Modified: 2016-07-12	//
//																																	//
//	Purpose:																														//
//																																	//
//	Result: Returns TRUE if successful.  Otherwise returns FALSE.												//
//																																	//
//	Note: This function does not return until the modal dialog box is closed.								//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

bool SWOT_App::OpenMainWindow()
{
	bool	bStatus = TRUE;

	if ( SWOT_DlgSetWndOnTop::ShowSetWndOnTop() == -1 )
	{
		m_nExitValue = aevError_OpenMainWindow;
		::MessageBeep( MB_ICONHAND );
		bStatus = FALSE;
	}

	return( bStatus );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-11  Modified: 2016-07-11	//
//																																	//
//	Purpose:	Patch for the GetWindowRect() function used in Vista and more recent OS.					//
//				The difference in the results from these two functions is only noticeable when a		 	//
//				window, that is not resizable, has a border that is not thin.									//
//																																	//
//	Result: Returns the real size of the window rectangle that has its border thickness increased 	//
//			  by the Aero feature introduced in Vista.																//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

bool SWOT_App::GetWindowBoundsRect( HWND hWnd, LPRECT lpRect )
{
	bool		bStatus = FALSE;
	BOOL		nIsEnabled;

//---------------------------------------------------------------------------------------------------

	if ( lpRect != 0 )
	{
		if ( m_hDwmApiDll != 0 )	// Do we need to fix the mess created by the Aero nice looking feature introduced in Vista?
		{
			if ( (m_pfnDwmIsCompositionEnabled != 0) && (m_pfnDwmGetWindowAttribute != 0) )
			{
				if ( SUCCEEDED( m_pfnDwmIsCompositionEnabled( &nIsEnabled ) ) && (nIsEnabled != 0) )
				{
					bStatus = SUCCEEDED( m_pfnDwmGetWindowAttribute( hWnd, DWMWA_EXTENDED_FRAME_BOUNDS, lpRect, sizeof( RECT ) ) );
				}
			}
		} 

		//------------------------------------------------

		if ( !bStatus ) bStatus = (::GetWindowRect( hWnd, lpRect ) != 0);	// Use old way of getting the window rectandle?
	}

//---------------------------------------------------------------------------------------------------

	return( bStatus );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-11  Modified: 2016-09-14	//
//																																	//
//	Purpose: Returns TRUE if we are running under Vista or more recent OS and the Aero feature is	//
//				turned on.																										//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

bool SWOT_App::IsAeroEnabled()
{
	BOOL	nIsEnabled = FALSE;

	if ( (m_hDwmApiDll != 0) && (m_pfnDwmIsCompositionEnabled != 0) )	// Are we running under Vista or more recent OS?
	{
		if ( FAILED( m_pfnDwmIsCompositionEnabled( &nIsEnabled ) ) )
		{
			nIsEnabled = FALSE;	//	Just in case its value changed.
		}
	} 

	return( (nIsEnabled != 0) );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-11  Modified: 2016-07-11	//
//																																	//
//	Purpose:																														//
//																																	//
//	Result: Return FALSE only when the specified WebLink can not be found.									//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

bool SWOT_App::BrowseWebpageLink( LPCTSTR pcszWebpageLink, HWND hwndParent, bool bPromptOnError )
{
	bool	bStatus = TRUE;

//---------------------------------------------------------------------------------------------------
//	KNOWN BUG: If this application is started with the MS Visual Studio debugger, then the 'ShellExecute()' function
//				  may randomly cause this application to freeze and the MS Visual Studio to hang and restart.

	if ( (int)::ShellExecute( hwndParent, _T("open"), pcszWebpageLink, 0, _T("C:\\"), SW_SHOW ) <= HINSTANCE_ERROR )
	{	
		if ( bPromptOnError )
		{
			CString	strText;

			strText.Format( SWOT_FmtMsg_OpenWebsiteAddressFailed, pcszWebpageLink );
			::MessageBox( hwndParent, strText, NULL, (MB_ICONERROR | MB_OK) );
		}

		bStatus = FALSE;
	}

//---------------------------------------------------------------------------------------------------

	return( bStatus );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com  All rights reserved.  Created: 2001-05-11  Modified: 2016-09-15	//
//																																	//
//	Purpose:	Uses the shell's IShellLink and IPersistFile interfaces to create and store a shortcut	//
//				to the specified object.																					//
//																																	//
//	IMPORTANT: Prior to calling this function you must initialize Component Object Model (COM) with	//
//				  'OleInitialize()' or 'CoInitialize()'.																//
//																																	//
//	'pcszLinkPath': Full path and file name of the link file.  A typical path is "C:\Users\			//
//						 <UserName>\AppData\Roaming\Microsoft\Windows\Start Menu\Programs\					//
//						 <Software Name>\<Application Name.lnk>").													//
//																																	//
//	'pcszFilePath': Full path and file name of the shell link object.											//
//																																	//
//	'pcszWorkDir': May be set to NULL.																					//
//																																	//
//	'pcszArgs': May be set to NULL. 																						//
//																																	//
//	'pcszDescription': May be set to NULL.																				//
//																																	//
//	'pcszIconPath' May be set to NULL.																					//
//																																	//
//	'cnIcon': When positive, indicates the icon order position of apparition in the file pointed 	//
//				 by 'pcszIconPath'.  When negative, its absolute value indicates the icon real Id		//
//				 number assigned during compilation.																	//
//																																	//
//	'cnShowCmd': 'SW_SHOWNORMAL', 'SW_SHOWMINNOACTIVE' or 'SW_SHOWMAXIMIZED'.								//
//																																	//
//	'cwHotkey': For details see 'IShellLink::GetHotkey()'.														//
//																																	//
// Note:	Do not put quotation marks in path strings.  The folder, where the link file pointed by	//
//			'pcszLinkPath' will be created, must already exist otherwise this function will fail.		//
//																																	//
//	Result: Returns the result of calling the member functions of the interfaces or -1 for other		//
//			  errors.  Test the returned value like that: if ( SUCCEEDED( nResult ) ) then no error.	//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

HRESULT SWOT_App::CreateLinkFile( LPCTSTR pcszLinkPath, LPCTSTR pcszFilePath, LPCTSTR pcszWorkDir, LPCTSTR pcszArgs,
											 LPCTSTR pcszDescription, LPCTSTR pcszIconPath, const int cnIcon, const int cnShowCmd, const WORD cwHotkey )
{
	HRESULT			nResult = S_OK;
	IShellLink	  *psl;
	IPersistFile  *ppf;
	WCHAR				wszLinkFileName[MAX_PATH];

//---------------------------------------------------------------------------------------------------

	if ( nResult == S_OK )
	{
		// Get a pointer to the IShellLink interface.  It is assumed that 'OleInitialize()' or 'CoInitialize()' has already been called.
		nResult = ::CoCreateInstance( CLSID_ShellLink, 0, CLSCTX_INPROC_SERVER, IID_IShellLink, (void **)&psl );

		if ( SUCCEEDED( nResult ) )
		{
			nResult = psl->QueryInterface( IID_IPersistFile, (void **)&ppf );		// Get a pointer to the IPersistFile interface.

			if ( SUCCEEDED( nResult ) )
			{

//---------------------------------------------------------------------------------------------------

				FOREVER
				{
					nResult = psl->SetPath( pcszFilePath );		//	Set the path and file name of a shell link object.

					if ( FAILED( nResult ) ) break;

					//------------------------------------------------

					if ( pcszWorkDir != NULL )
					{
						nResult = psl->SetWorkingDirectory( pcszWorkDir );		//	Set the name of the working directory for a shell link object.

						if ( FAILED( nResult ) ) break;
					}

					//------------------------------------------------

					if ( pcszArgs != NULL )
					{
						nResult = psl->SetArguments( pcszArgs );		//	Set the command-line arguments associated with a shell link object.

						if ( FAILED( nResult ) ) break;
					}

					//------------------------------------------------

					if ( pcszDescription != NULL )
					{
						nResult = psl->SetDescription( pcszDescription );		//	Set the description string for a shell link object.

						if ( FAILED( nResult ) ) break;
					}

					//------------------------------------------------

					if ( pcszIconPath != NULL )
					{
						nResult = psl->SetIconLocation( pcszIconPath, cnIcon );	//	Set the location (path and index) of the icon for a shell link object.

						if ( FAILED( nResult ) ) break;
					}

					//------------------------------------------------

					nResult = psl->SetShowCmd( cnShowCmd );	//	Set the show (SW_????) command for a shell link object.

					if ( FAILED( nResult ) ) break;

					//------------------------------------------------

					nResult = psl->SetHotkey( cwHotkey );		//	Set the hot key for a shell link object.

					if ( FAILED( nResult ) ) break;

					//------------------------------------------------

					break;
				}

//---------------------------------------------------------------------------------------------------

				if ( SUCCEEDED( nResult ) )
				{
					// Ensure string is ANSI.
					if ( ::MultiByteToWideChar( CP_ACP, 0, pcszLinkPath, -1, wszLinkFileName, MAX_PATH ) != 0 )
						nResult = ppf->Save( wszLinkFileName, TRUE );	// Save the shortcut via the 'IPersistFile::Save()' method.
					else
						nResult = -1;
				}

				ppf->Release();		// Release the pointer to IPersistFile.
			}

			psl->Release();			// Release the pointer to IShellLink.
		}
	}

//---------------------------------------------------------------------------------------------------

	return( nResult );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com  All rights reserved.  Created: 2001-05-12  Modified: 2016-09-28	//
//																																	//
//	Purpose:	This function is more elaborated than the basic 'CreateLinkFile()' function.				//
//																																	//
//	IMPORTANT: Prior to calling this function you must initialize Component Object Model (COM) with	//
//				  'OleInitialize()' or 'CoInitialize()'.																//
//																																	//
//	'pcszLinkName': Must contain only a spec name without any path or extension.							//
//																																	//
//	'pcszSubMenuFolder': May be set to NULL.  Used to specify one or more submenus (folders) where	//
//								the shortcut will be actually created.													//
//																																	//
//	'pcszArgs': May be set to NULL. 																						//
//																																	//
//	'pcszDescription': May be set to NULL.																				//
//																																	//
//	'pcszAbsoluteIconFileName': May be set to NULL. Usually identical to 'pcszAbsoluteAppFileName'. //
//																																	//
//	'cnIcon': When positive, indicates the icon order position of apparition in the file pointed 	//
//				 by 'pcszAbsoluteIconFileName'.  When negative, its absolute value indicates the icon	//
//				 real Id number assigned during compilation.															//
//																																	//
//	'cbVisibleToAllUsers': When set to TRUE, your application must have the administrator				//
//								  privileges otherwise the icon will not be created.								//
//																																	//
//	'cbSmartCreationDeletion': When set to TRUE, if the application specified by							//
//										'pcszAbsoluteAppFileName' cannot be found then the shortcut				//
//										specified by 'pcszLinkName', 'pcszSubMenuFolder',							//
//										'cbVisibleToAllUsers' and 'cbCreateItOnDesktopInstead' will be			//
//										deleted if it was already existing.												//
//																																	//
// Note:	The link file specified by 'pcszLinkName' will be created or overwritten whatever			//
//			it has its read only attribute set or not.																//
//																																	//
//	Result: Returns the result of calling the functions inside this function or -1 for other			//
//			  errors.  Test the returned value like that: if ( SUCCEEDED( nResult ) ) then no error.	//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

HRESULT SWOT_App::CreateShortcutFile( LPCTSTR pcszLinkName, LPCTSTR pcszSubMenuFolder, LPCTSTR pcszAbsoluteAppFileName,
												  LPCTSTR pcszStartingFolder, LPCTSTR pcszArgs, LPCTSTR pcszDescription,
												  LPCTSTR pcszAbsoluteIconFileName, const int cnIcon, const int cnShowCmd, const WORD cwHotkey,
												  const bool cbVisibleToAllUsers, const bool cbCreateItOnDesktopInstead, const bool cbSmartCreationDeletion )
{
	HRESULT			nResult	 = -1;		// Set to error by default.
	bool				bCreateIt = TRUE;
	int				nFolderId;
	unsigned int	unAttributes;
	TCHAR				szLinkRootFolder[MAX_PATH], szLinkFolderName[MAX_PATH], szLinkFileName[MAX_PATH];

//---------------------------------------------------------------------------------------------------

	if ( cbVisibleToAllUsers ) nFolderId = ((cbCreateItOnDesktopInstead) ? CSIDL_COMMON_DESKTOPDIRECTORY : CSIDL_COMMON_PROGRAMS);
	else								nFolderId = ((cbCreateItOnDesktopInstead) ? CSIDL_DESKTOPDIRECTORY : CSIDL_PROGRAMS);

//---------------------------------------------------------------------------------------------------

	FOREVER
	{
		_tcsEmpty( szLinkRootFolder );	//	Safer code.
		nResult = ::SHGetFolderPath( 0, nFolderId, 0, SHGFP_TYPE_CURRENT, szLinkRootFolder );

		if ( nResult != S_OK )
		{
			_tcsEmpty( szLinkRootFolder );	//	Safer code.
			nResult = ::SHGetFolderPath( 0, nFolderId, 0, SHGFP_TYPE_DEFAULT, szLinkRootFolder );
		}

#ifdef _UNICODE
		if ( (nResult != S_OK) && (nResult != E_FAIL) ) break;
#else
		if ( (nResult != S_OK) && (nResult != S_FALSE) ) break;
#endif
		//------------------------------------------------

		nResult = -1;		// Set to error by default.

		if ( _tcsIsEmpty( szLinkRootFolder ) || ::PathIsRelative( szLinkRootFolder ) ) break;

		if ( !SWOT_CreateFolder( szLinkRootFolder ) ) break;	//	Creation of the root menu folder.  Just in case.

		//------------------------------------------------

		_tcscpy_s( szLinkFolderName, szLinkRootFolder );

		if ( !::PathAppend( szLinkFolderName, ((pcszSubMenuFolder != NULL) ? pcszSubMenuFolder : _T("")) ) ) break;

		_tcscpy_s( szLinkFileName, szLinkFolderName );

		if ( !::PathAppend( szLinkFileName, pcszLinkName ) || !SWOT_PathAppendExtension( szLinkFileName, SWOT_EXTENSION__lnk ) ) break;

		if ( ::PathIsRelative( pcszAbsoluteAppFileName ) ) break;

		if ( !_tcsIsEmpty_s( pcszAbsoluteIconFileName ) && ::PathIsRelative( pcszAbsoluteIconFileName ) ) break;

		//------------------------------------------------

		if ( (unAttributes = ::GetFileAttributes( szLinkFileName )) != INVALID_FILE_ATTRIBUTES )	// File exists?
		{
			if ( (unAttributes & FILE_ATTRIBUTE_READONLY) != 0 )	// File is Read-only?
			{
				if ( ::SetFileAttributes( szLinkFileName, (unAttributes & ~FILE_ATTRIBUTE_READONLY) ) == 0 ) break;
			}
		}

		//------------------------------------------------

		if ( cbSmartCreationDeletion && !::PathFileExists( pcszAbsoluteAppFileName ) )
		{
			bCreateIt = FALSE;

			if ( ::PathFileExists( szLinkFileName ) && !::DeleteFile( szLinkFileName ) ) break;
		}

		//------------------------------------------------

		if ( bCreateIt )
		{
			if ( !SWOT_CreateFolder( szLinkFolderName ) ) break;	//	Creation of the 'pcszSubMenuFolder' folder.

			nResult = CreateLinkFile( szLinkFileName, pcszAbsoluteAppFileName, pcszStartingFolder, pcszArgs,
											  pcszDescription, pcszAbsoluteIconFileName, cnIcon, cnShowCmd, cwHotkey );
			break;
		}

		nResult = S_OK;
		break;
	}

//---------------------------------------------------------------------------------------------------

	return( nResult );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-03-25  Modified: 2016-09-21	//
//																																	//
//	Purpose:																														//
//																																	//
//	IMPORTANT: Prior to calling this function you must initialize Component Object Model (COM) with	//
//				  'OleInitialize()' or 'CoInitialize()'.																//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

bool SWOT_App::CreateDesktopShortcut( const bool cbPlaySound )
{
	bool		bStatus = FALSE;

//---------------------------------------------------------------------------------------------------

	if ( !_tcsIsEmpty( m_szModuleFileName ) )	//	Additional checking just in case.
	{
		if ( SUCCEEDED( CreateShortcutFile( SWOT_Txt_LinkName_SetWndOnTop, NULL, m_szModuleFileName, m_szCurrentDirAtStart,
				 NULL, SWOT_Txt_LinkDesc_SetWndOnTop, m_szModuleFileName, -101, SW_SHOWNORMAL, 0, FALSE, TRUE ) ) )
		{
			bStatus = TRUE;
		}
	}

//---------------------------------------------------------------------------------------------------

	if ( cbPlaySound )
	{
		::PlaySound( MAKEINTRESOURCE( (bStatus ? IDR_SHORTCUT_CREATED_WAVE : IDR_UHOH_MSG_WAVE) ),
						 m_hInstance, (SND_ASYNC | SND_RESOURCE | SND_NODEFAULT) );
	}

	return( bStatus );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2012-12-11  Modified: 2016-07-12	//
//																																	//
//	Purpose:	Copy the text pointed by 'pcszText' and 'pcszTDST' to the clipboard using the				//
//				'CF_TEXT' format and 'cunRCF_for_TDST' format.														//
//																																	//
//	'csztTextLength': When set to -1, the text length is auto-calculated with _tcslen().  A null 	//
//							terminator is automatically added to the text placed in the clipboard.			//
//																																	//
//			Example: If the text pointed by 'pcszText' is "X\0Y\0" (a string with a null terminator	//
//						 in its middle and at its end but before the last null terminator), you must		//
//						 set 'csztTextLength' to 4 and the text in the clipboard will be						//
//						 { 'X', '\0', 'Y', '\0', '\0' }.																	//
//						If the text pointed by 'pcszText' is "XY" (a string with the XY characters and  	//
//						 with a null terminator), you can set 'csztTextLength' to 2 or to -1 and the		//
//						 text in the clipboard will be { 'X', 'Y', '\0' }.											//
//																																	//
//	'pcszTDST': May be 0 if only 'pcszText' is enough for the clipboard.										//
//																																	//
//	'csztTDSTLength': Same as 'csztTextLength' but associated with 'pcszTDST'.								//
//																																	//
//	'cunRCF_for_TDST': Registered Clipboard Format used to describe 'pcszTDST'.  If it equals 0 		//
//							 then 'pcszTDST' and 'csztTDSTLength' are ignored.										//
//																																	//
// 'hwndNewOwner': Handle to the window to be associated with the open clipboard.  If this			//
//						 argument is 0, then the opened clipboard is associated with the current task.	//
//																																	//
//	Result: Returns TRUE if successful.  Otherwise returns FALSE.												//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

bool SWOT_App::CopyTDSTToClipboard( LPCTSTR pcszText, LPCTSTR pcszTDST, const unsigned int cunRCF_for_TDST,
												const size_t csztTextLength, const size_t csztTDSTLength, HWND hwndNewOwner )
{
	bool			bStatus		 = TRUE;
	HGLOBAL		hglbCopyData = 0;
	DWORD			dwCopyDataSize;
	LPTSTR		pszCopyText;
	size_t		sztTextLength;

//---------------------------------------------------------------------------------------------------

	if ( OpenClipboard( hwndNewOwner ) )
	{
		if ( EmptyClipboard() )
		{
			if ( bStatus && (cunRCF_for_TDST != 0) && (pcszTDST != 0) )		//	Most significant format first.
			{
				sztTextLength  = ((csztTDSTLength == -1) ? _tcslen( pcszTDST ) : csztTDSTLength);
				dwCopyDataSize = ((sztTextLength + EOS_CHAR_COUNT) * sizeof( TCHAR ));

				if ( (hglbCopyData = ::GlobalAlloc( GMEM_MOVEABLE, dwCopyDataSize )) != 0 )
				{
					if ( (pszCopyText = (LPTSTR)::GlobalLock( hglbCopyData )) != 0 )
					{
						memcpy( pszCopyText, pcszTDST, (sztTextLength * sizeof( TCHAR )) );
						pszCopyText[sztTextLength] = _T('\0');

						::GlobalUnlock( hglbCopyData );
						pszCopyText = 0;

						if ( SetClipboardData( cunRCF_for_TDST, hglbCopyData ) != 0 ) 
						{
							hglbCopyData = 0;		//	Function is successful so the memory is now owned by the system.
						}
	 					else bStatus = FALSE;
					}
	 				else bStatus = FALSE;

					//------------------------------------------------

					if ( hglbCopyData != 0 )
					{
						::GlobalFree( hglbCopyData );
						hglbCopyData = 0;
					}
				}           
	 			else bStatus = FALSE;
			}

//---------------------------------------------------------------------------------------------------

			if ( bStatus )
			{
				sztTextLength  = ((csztTextLength == -1) ? _tcslen( pcszText ) : csztTextLength);
				dwCopyDataSize = ((sztTextLength + EOS_CHAR_COUNT) * sizeof( TCHAR ));

				if ( (hglbCopyData = ::GlobalAlloc( GMEM_MOVEABLE, dwCopyDataSize )) != 0 )
				{
					if ( (pszCopyText = (LPTSTR)::GlobalLock( hglbCopyData )) != 0 )
					{
						memcpy( pszCopyText, pcszText, (sztTextLength * sizeof( TCHAR )) );
						pszCopyText[sztTextLength] = _T('\0');

						::GlobalUnlock( hglbCopyData );
						pszCopyText = 0;

						if ( SetClipboardData( ((sizeof( TCHAR ) == 1) ? CF_TEXT : CF_UNICODETEXT), hglbCopyData ) != 0 ) 
						{
							hglbCopyData = 0;		//	Function is successful so the memory is now owned by the system.
						}
	 					else bStatus = FALSE;
					}
	 				else bStatus = FALSE;

					//------------------------------------------------

					if ( hglbCopyData != 0 )
					{
						::GlobalFree( hglbCopyData );
						hglbCopyData = 0;
					}
				}           
	 			else bStatus = FALSE;
			}
		}
		else bStatus = FALSE;

		//------------------------------------------------

		if ( !CloseClipboard() ) bStatus = FALSE;
	}
	else bStatus = FALSE;

//---------------------------------------------------------------------------------------------------

	return( bStatus );
}
