/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-07  Modified: 2016-09-28	//
//																																	//
// SWOT_App.h : Header of the 'SWOT_App' class and functions.													//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

//#include "SWOT_App.h"
#pragma once

#include "resource.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////

class SWOT_App
{
public:

	enum AppExitValue		//	Once assigned, do not change the values.
	{
		aevNoError								 = 0,
		aevError_BadArguments				 = 1001,
		aevError_ModuleFileName				 = 1002,
		aevError_ApplicationVersion		 = 1003,
		aevError_CurrentDirectory			 = 1009,
		aevError_OleInitialize				 = 1011,
		aevError_OleInitWrongCompObj		 = 1012,
		aevError_InstallPrivateFonts		 = 1020,
		aevError_OpenMainWindow				 = 1027,
	};

	//------------------------------------------------

	enum IconIdInRes : unsigned int
	{
		iidirMainWnd				 = IDI_SETWNDONTOP,
		iidirMainWnd_Small		 = IDI_SETWNDONTOP_SMALL,
		iidirAbout					 = IDI_ABOUT,
		iidirAdeluc					 = IDI_ADELUC,
		iidirClose					 = IDI_CLOSE,
		iidirSaveCurSettings		 = IDI_SAVE_FILE,
		iidirNewShortcut			 = IDI_NEW_SHORTCUT,
		iidirOnOff					 = IDI_ON_OFF,
		iidirCopy					 = IDI_COPY,
		iidirPopupMenu				 = IDI_POPUP_MENU,
		iidirWindowWithoutTarget = IDI_WINWITHOUTTARGET,
		iidirWindowWithTarget	 = IDI_WINWITHTARGET,
	};

	//------------------------------------------------

	typedef HRESULT (WINAPI * PFN_DwmIsCompositionEnabled)( __out BOOL * isEnabled );
	typedef HRESULT (WINAPI * PFN_DwmGetWindowAttribute  )( __in  HWND hwnd, __in  DWORD dwAttribute, __out PVOID pvAttribute, DWORD cbAttribute );

//---------------------------------------------------------------------------------------------------
public:

	TCHAR						m_szCurrentDirAtStart[MAX_PATH];						// Read only.
	TCHAR						m_szModuleFileName[MAX_PATH];							// Read only.

   HINSTANCE				m_hInstance;
   LPTSTR					m_pszCmdLine;
   int						m_nCmdShow;
	int						m_nExitValue;

	unsigned __int64		m_un64AppFileVersion;			//	Application file version.
	unsigned __int64		m_un64ProductVersion;			//	Package version.

	CString					m_strRegKey__AppKeyName;
	bool						m_bIsOleInitialized;

	HANDLE					m_hMemFont_SegoeUI_TTF;

	//------------------------------------------------

	HINSTANCE							m_hDwmApiDll;
	PFN_DwmIsCompositionEnabled	m_pfnDwmIsCompositionEnabled;
	PFN_DwmGetWindowAttribute		m_pfnDwmGetWindowAttribute;

//---------------------------------------------------------------------------------------------------
protected:
	static SWOT_App  *m_pGlobal;
#ifdef _DEBUG
	static int			m_nObjectCount;
#endif

//---------------------------------------------------------------------------------------------------
public:
	SWOT_App();
private:	// Copy constructor and assignment operator are not supported in this class.
	SWOT_App( const SWOT_App & rc ) { ASSERT( 0 ); }
	SWOT_App & operator = ( const SWOT_App & rc ) { ASSERT( 0 );		return( *this ); }
public:
	~SWOT_App();

	//------------------------------------------------

	static SWOT_App * GetGlobalObject()
	{
		ASSERT( m_pGlobal != 0 );	// Warn if no object is currently defined in the application.
		return( m_pGlobal );
	}

//---------------------------------------------------------------------------------------------------

	bool Initialize( HINSTANCE hInstanceApp, LPTSTR pszCmdLine, int nCmdShow );
	void Cleanup();

	bool InstallPrivateFonts();
	void UninstallPrivateFonts();

	bool OpenMainWindow();
	void CloseMainWindow() {};	//	Nothing to do.

	//------------------------------------------------

	bool GetWindowBoundsRect( HWND hWnd, LPRECT lpRect );
	bool IsAeroEnabled();

	//------------------------------------------------

	bool BrowseWebpageLink( LPCTSTR pcszWebpageLink, HWND hwndParent = 0, bool bPromptOnError = TRUE );

	//------------------------------------------------

	HRESULT  CreateLinkFile( LPCTSTR pcszLinkPath, LPCTSTR pcszFilePath, LPCTSTR pcszWorkDir = NULL,
									 LPCTSTR pcszArgs = NULL, LPCTSTR pcszDescription = NULL, LPCTSTR pcszIconPath = NULL,
									 const int cnIcon = 0, const int cnShowCmd = SW_SHOWNORMAL, const WORD cwHotkey = 0 );

	HRESULT	CreateShortcutFile( LPCTSTR pcszLinkName, LPCTSTR pcszSubMenuFolder, LPCTSTR pcszAbsoluteAppFileName,
										  LPCTSTR pcszStartingFolder = NULL, LPCTSTR pcszArgs = NULL, LPCTSTR pcszDescription = NULL,
										  LPCTSTR pcszAbsoluteIconFileName = NULL, const int cnIcon = 0,
										  const int cnShowCmd = SW_SHOWNORMAL, const WORD cwHotkey = 0, const bool cbVisibleToAllUsers = FALSE,
										  const bool cbCreateItOnDesktopInstead = FALSE, const bool cbSmartCreationDeletion = TRUE );

	bool		CreateDesktopShortcut( const bool cbPlaySound = TRUE );

	//------------------------------------------------

	bool CopyTDSTToClipboard( LPCTSTR pcszText, LPCTSTR pcszTDST = 0, const unsigned int cunRCF_for_TDST = 0,
												  const size_t csztTextLength = -1, const size_t csztTDSTLength = -1, HWND hwndNewOwner = 0 );
	bool CopyInfoToClipboard();
};

//===================================================================================================

inline	SWOT_App *	SWOT_GetGlobalApp()		{ return( SWOT_App::GetGlobalObject() ); }

extern	SWOT_App		ThisApp;

/////////////////////////////////////////////////////////////////////////////////////////////////////
