/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-07  Modified: 2017-11-20	//
//																																	//
// SWOT_DlgSetWndOnTop.cpp : Implementation of the "Set Window On Top & Get Info" dialog box.		//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SWOT_DlgSetWndOnTop.h"
#include "SetWndOnTop.h"
#include "SWOT_App.h"
#include <mmsystem.h>
#include "SWOT_Global.h"

#ifndef _INC_WINDOWSX
#include <windowsx.h>
#endif

/////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-06-18  Modified: 2016-08-20	//
//																																	//
//	Purpose:	Definitions of the constructor and the destructor.													//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

SWOT_DlgSetWndOnTop::SWOT_DlgSetWndOnTop( HWND hwndParent, HINSTANCE hInstance, LPCTSTR pcszTemplate )
{
	SWOT_App   *pThisApp = SWOT_GetGlobalApp();

//---------------------------------------------------------------------------------------------------

	m_hwndParent = hwndParent;
	m_hInstance	 = ((hInstance != 0) ? hInstance : pThisApp->m_hInstance);	// Auto set don't work with static classes.

	// Auto set always work with derived constructor.
	if ( IS_INTRESOURCE( pcszTemplate ) ) m_strTemplate.Format( _T("#%lu"), (unsigned int)pcszTemplate );
	else											  m_strTemplate = pcszTemplate;

	m_strHtmlHelpFileName = URL_SWOT_WEBSITE;

	//------------------------------------------------

	m_hWnd	  = 0;
	m_npResult = 0;
	m_pCurMsg  = 0;

	//------------------------------------------------
	
	m_hwndCurSelWnd			  = 0;
	m_hwndCurSelWnd_TopParent = 0;
	m_hwndLastRectDrawn		  = 0;
	m_hcursorTarget			  = ::LoadCursor( pThisApp->m_hInstance, MAKEINTRESOURCE( IDC_CURSOR_TARGET ) );
	m_bIsDlgTopMost			  = TRUE;
	m_bIsAutoFindRootParent	  = TRUE;
	m_bIsDrawInvertedFrame	  = TRUE;
	m_bIsSelWndTopMost		  = FALSE;
	m_bIsMouseCaptured		  = FALSE;

	//------------------------------------------------

	m_hwndIC_TargetIcon = 0;

	m_hwndED_Title				 = 0;
	m_hwndED_Class				 = 0;
	m_hwndED_Descriptor		 = 0;
	m_hwndED_Identifier		 = 0;
	m_hwndED_Style				 = 0;
	m_hwndED_ExtStyle			 = 0;
	m_hwndED_Parent			 = 0;
	m_hwndED_Rectangle		 = 0;
	m_hwndCK_KeepSelWndOnTop = 0;

	m_hwndBT_CopyInfoToClipboard = 0;
	m_hwndBT_Menu					  = 0;

	//------------------------------------------------

//	m_bIsTrackingMouseLeaveEnabled = FALSE;
	m_bModalMode						 = TRUE;
//	m_pDataBkp							 = 0;
}

//===================================================================================================

SWOT_DlgSetWndOnTop::~SWOT_DlgSetWndOnTop()
{
	JCH_DEBUG_FILL_WITH_0xCC( m_hwndParent )
	JCH_DEBUG_FILL_WITH_0xCC( m_hInstance )

	JCH_DEBUG_FILL_WITH_0xCC( m_hWnd )
	JCH_DEBUG_FILL_WITH_0xCC( m_npResult )
	JCH_DEBUG_FILL_WITH_0xCC( m_pCurMsg )

	JCH_DEBUG_FILL_WITH_0xCC( m_hwndCurSelWnd )
	JCH_DEBUG_FILL_WITH_0xCC( m_hwndCurSelWnd_TopParent )
	JCH_DEBUG_FILL_WITH_0xCC( m_hwndLastRectDrawn )
	JCH_DEBUG_FILL_WITH_0xCC( m_hcursorTarget )
	JCH_DEBUG_FILL_WITH_0xCC( m_bIsDlgTopMost )
	JCH_DEBUG_FILL_WITH_0xCC( m_bIsAutoFindRootParent )
	JCH_DEBUG_FILL_WITH_0xCC( m_bIsDrawInvertedFrame )
	JCH_DEBUG_FILL_WITH_0xCC( m_bIsSelWndTopMost )
	JCH_DEBUG_FILL_WITH_0xCC( m_bIsMouseCaptured )

	JCH_DEBUG_FILL_WITH_0xCC( m_hwndIC_TargetIcon )

	JCH_DEBUG_FILL_WITH_0xCC( m_hwndED_Title )
	JCH_DEBUG_FILL_WITH_0xCC( m_hwndED_Class )
	JCH_DEBUG_FILL_WITH_0xCC( m_hwndED_Descriptor )
	JCH_DEBUG_FILL_WITH_0xCC( m_hwndED_Identifier )
	JCH_DEBUG_FILL_WITH_0xCC( m_hwndED_Style )
	JCH_DEBUG_FILL_WITH_0xCC( m_hwndED_ExtStyle )
	JCH_DEBUG_FILL_WITH_0xCC( m_hwndED_Parent )
	JCH_DEBUG_FILL_WITH_0xCC( m_hwndED_Rectangle )
	JCH_DEBUG_FILL_WITH_0xCC( m_hwndCK_KeepSelWndOnTop )

	JCH_DEBUG_FILL_WITH_0xCC( m_hwndBT_CopyInfoToClipboard )
	JCH_DEBUG_FILL_WITH_0xCC( m_hwndBT_Menu )

//	JCH_DEBUG_FILL_WITH_0xCC( m_bIsTrackingMouseLeaveEnabled )
	JCH_DEBUG_FILL_WITH_0xCC( m_bModalMode )
//	JCH_DEBUG_FILL_WITH_0xCC( m_pDataBkp )
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-06-18  Modified: 2016-06-18	//
//																																	//
//	Purpose:																														//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

INT_PTR SWOT_DlgSetWndOnTop::ShowSetWndOnTop( HWND hwndParent )
{
	SWOT_App				  *pThisApp = SWOT_GetGlobalApp();
	SWOT_DlgSetWndOnTop	dlgSetWndOnTop( hwndParent, pThisApp->m_hInstance );

//---------------------------------------------------------------------------------------------------

	dlgSetWndOnTop.DoModal();

//---------------------------------------------------------------------------------------------------

	if ( ((dlgSetWndOnTop.m_npResult == -1) || (dlgSetWndOnTop.m_npResult == 0)) && (::GetLastError() == ERROR_BAD_ARGUMENTS) )
	{
		dlgSetWndOnTop.m_npResult = -1;
	}

//---------------------------------------------------------------------------------------------------

	return( dlgSetWndOnTop.m_npResult );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2013-09-13  Modified: 2013-09-13	//
//																																	//
//	Purpose:																														//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

void SWOT_DlgSetWndOnTop::SetTargetIcon( const bool cbWindowWithTarget )
{
	HICON		hiconTmp;

	if ( (hiconTmp = (HICON)SendDlgItemMessage( IDC_TargetIcon_IC, STM_GETIMAGE, IMAGE_ICON, 0 )) != 0 )
		::DestroyIcon( hiconTmp );

	::SendMessage( m_hwndIC_TargetIcon, STM_SETIMAGE, IMAGE_ICON, (LPARAM)::LoadImage( SWOT_GetGlobalApp()->m_hInstance,
						MAKEINTRESOURCE( (cbWindowWithTarget ? SWOT_App::iidirWindowWithTarget : SWOT_App::iidirWindowWithoutTarget) ),
						IMAGE_ICON, 32, 32, LR_DEFAULTCOLOR ) );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-06-18  Modified: 2016-08-20	//
//																																	//
//	Purpose:																														//
//																																	//
//	'hwndSource': Window from which we want to extract information.  Do not forget that if the		//
//					  'm_bIsAutoFindRootParent' is TRUE then the information will be extracted from  	//
//					  the top most parent of 'hwndSource' instead.													//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

void SWOT_DlgSetWndOnTop::SetInfoControls( HWND hwndSource )
{
	bool			bIsWndHandleValid = TRUE;
	bool			bIsInfoValid		= FALSE;
	bool			bIsParentExist		= TRUE;
	bool			bIsChecked, bIsFocusControlDisabled;
	HWND			hwndInfoFrom, hwndTopParent, hwndParent, hwndTmpParent, hwndCurFocus;
	WINDOWINFO	wndInfo;
	CRect			rectWnd;
	TCHAR			szClassName[257];		//	See 'WNDCLASS.lpszClassName' for details.
	CString		strTitle, strDescriptor, strIdentifier, strStyle, strExtStyle, strParent, strRectangle;
	CString		strTitle_Old, strClassName_Old, strDescriptor_Old, strIdentifier_Old, strStyle_Old, strExtStyle_Old, strParent_Old, strRectangle_Old;

	wndInfo.cbSize = sizeof( WINDOWINFO );
	_tcsEmpty( szClassName );

//---------------------------------------------------------------------------------------------------

	if ( (hwndSource != 0) && ::IsWindow( hwndSource ) && (hwndSource != m_hWnd) )
	{
		for( hwndTopParent = hwndTmpParent = hwndSource;
			  ((hwndTmpParent = ::GetParent( hwndTmpParent )) != 0); hwndTopParent = hwndTmpParent )
		{
			if ( hwndTmpParent == m_hWnd )	//	Pointing inside this application main window?
			{
				bIsWndHandleValid = FALSE;
				break;
			}
		}
	}
	else bIsWndHandleValid = FALSE;

//---------------------------------------------------------------------------------------------------

	if ( bIsWndHandleValid )
	{
		hwndInfoFrom = (m_bIsAutoFindRootParent ? hwndTopParent : hwndSource);

		if ( (::GetClassName( hwndInfoFrom, szClassName, _countof( szClassName ) ) != 0) && (::GetWindowInfo( hwndInfoFrom, &wndInfo ) != 0) )
		{
			m_hwndCurSelWnd			  = hwndSource;
			m_hwndCurSelWnd_TopParent = hwndTopParent;
			bIsParentExist				  = ((hwndParent = ::GetParent( hwndInfoFrom )) != 0);
			m_bIsSelWndTopMost		  = ((wndInfo.dwExStyle & WS_EX_TOPMOST) != 0);

			strTitle = SWOT_GetWindowText( hwndInfoFrom );

			strDescriptor.Format( _T("0x%08p"), (void *)hwndInfoFrom );
			strIdentifier.Format( _T("%I64d"), (__int64)::GetWindowLongPtr( hwndInfoFrom, GWLP_ID ) );

			strStyle.Format( _T("0x%08X"), wndInfo.dwStyle );
			strExtStyle.Format( _T("0x%08X"), wndInfo.dwExStyle );
			strParent.Format( _T("0x%08p"), (void *)hwndParent );

			rectWnd = wndInfo.rcWindow;

			if ( hwndInfoFrom != hwndTopParent )
			{
				::ScreenToClient( hwndTopParent, (LPPOINT)&rectWnd );
				::ScreenToClient( hwndTopParent, ((LPPOINT)&rectWnd) + 1 );
			}

			strRectangle.Format( _T("(%d, %d), (%d, %d)   %d  %d"), rectWnd.left, rectWnd.top,
										rectWnd.right, rectWnd.bottom, rectWnd.Width(), rectWnd.Height() );
		}
		else bIsWndHandleValid = FALSE;
	}

	//------------------------------------------------

	if ( !bIsWndHandleValid )
	{
		m_hwndCurSelWnd			  = 0;
		m_hwndCurSelWnd_TopParent = 0;
		m_bIsSelWndTopMost		  = FALSE;
	}

//---------------------------------------------------------------------------------------------------

	bIsInfoValid = bIsWndHandleValid;
	hwndCurFocus = ::GetFocus();

	bIsFocusControlDisabled = (!bIsInfoValid && ((hwndCurFocus == m_hwndED_Title)		  || (hwndCurFocus == m_hwndED_Class) ||
																(hwndCurFocus == m_hwndED_Descriptor) || (hwndCurFocus == m_hwndED_Identifier) ||
																(hwndCurFocus == m_hwndED_Style)		  || (hwndCurFocus == m_hwndED_ExtStyle) ||
																(hwndCurFocus == m_hwndED_Parent)	  || (hwndCurFocus == m_hwndED_Rectangle) ||
																(hwndCurFocus == m_hwndCK_KeepSelWndOnTop) || (hwndCurFocus == m_hwndBT_CopyInfoToClipboard)));

//---------------------------------------------------------------------------------------------------

	strTitle_Old		= SWOT_GetWindowText( m_hwndED_Title		);
	strClassName_Old  = SWOT_GetWindowText( m_hwndED_Class		);
	strDescriptor_Old = SWOT_GetWindowText( m_hwndED_Descriptor );
	strIdentifier_Old = SWOT_GetWindowText( m_hwndED_Identifier );
	strStyle_Old		= SWOT_GetWindowText( m_hwndED_Style		);
	strExtStyle_Old	= SWOT_GetWindowText( m_hwndED_ExtStyle	);
	strParent_Old		= SWOT_GetWindowText( m_hwndED_Parent		);
	strRectangle_Old	= SWOT_GetWindowText( m_hwndED_Rectangle  );

	if ( strTitle_Old		  != strTitle		 ) ::SendMessage( m_hwndED_Title		 , WM_SETTEXT, 0, (LPARAM)strTitle.GetString()		 );
	if ( strClassName_Old  != szClassName	 ) ::SendMessage( m_hwndED_Class		 , WM_SETTEXT, 0, (LPARAM)szClassName					 );
	if ( strDescriptor_Old != strDescriptor ) ::SendMessage( m_hwndED_Descriptor, WM_SETTEXT, 0, (LPARAM)strDescriptor.GetString() );
	if ( strIdentifier_Old != strIdentifier ) ::SendMessage( m_hwndED_Identifier, WM_SETTEXT, 0, (LPARAM)strIdentifier.GetString() );
	if ( strStyle_Old		  != strStyle		 ) ::SendMessage( m_hwndED_Style		 , WM_SETTEXT, 0, (LPARAM)strStyle.GetString()		 );
	if ( strExtStyle_Old   != strExtStyle	 ) ::SendMessage( m_hwndED_ExtStyle	 , WM_SETTEXT, 0, (LPARAM)strExtStyle.GetString()	 );
	if ( strParent_Old	  != strParent		 ) ::SendMessage( m_hwndED_Parent	 , WM_SETTEXT, 0, (LPARAM)strParent.GetString()		 );
	if ( strRectangle_Old  != strRectangle	 ) ::SendMessage( m_hwndED_Rectangle , WM_SETTEXT, 0, (LPARAM)strRectangle.GetString()	 );

	WiselyEnableWindow( GetDlgItem( IDC_Title_TX )		, bIsInfoValid );
	WiselyEnableWindow( GetDlgItem( IDC_Class_TX )		, bIsInfoValid );
	WiselyEnableWindow( GetDlgItem( IDC_Descriptor_TX ), bIsInfoValid );
	WiselyEnableWindow( GetDlgItem( IDC_Identifier_TX ), bIsInfoValid );
	WiselyEnableWindow( GetDlgItem( IDC_Style_TX )		, bIsInfoValid );
	WiselyEnableWindow( GetDlgItem( IDC_ExtStyle_TX )	, bIsInfoValid );
	WiselyEnableWindow( GetDlgItem( IDC_Parent_TX )		, bIsInfoValid );
	WiselyEnableWindow( GetDlgItem( IDC_Rectangle_TX )	, bIsInfoValid );

	WiselyEnableWindow( m_hwndCK_KeepSelWndOnTop, (bIsInfoValid && !bIsParentExist) );
	bIsChecked = (::IsDlgButtonChecked( m_hWnd, IDC_KeepSelWndOnTop_CK ) == BST_CHECKED);

	if ( (bIsChecked ^ m_bIsSelWndTopMost) ) ::CheckDlgButton( m_hWnd, IDC_KeepSelWndOnTop_CK, (m_bIsSelWndTopMost ? BST_CHECKED : BST_UNCHECKED) );

	WiselyEnableWindow( m_hwndBT_CopyInfoToClipboard, bIsInfoValid );

//---------------------------------------------------------------------------------------------------

	if ( bIsFocusControlDisabled )
	{
		GotoDlgCtrl( IDOK );		//	It is important to set the focus to an enabled control otherwise the shotkeys will stop working.
	}
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-06-18  Modified: 2016-06-18	//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

void SWOT_DlgSetWndOnTop::StartMouseCapture()
{
	m_bIsMouseCaptured = TRUE;	//	Must be before 'SetCapture()'.
	::SetCapture( m_hWnd );	
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-06-26  Modified: 2016-08-18	//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

void SWOT_DlgSetWndOnTop::EndMouseCapture()
{
	if ( m_bIsDrawInvertedFrame && !m_bIsAutoFindRootParent && (m_hwndLastRectDrawn != 0) ) ClearLastDrawnFrame();

	m_bIsMouseCaptured = FALSE;	//	Must be before 'ReleaseCapture()'.
	::ReleaseCapture();				//	This function will generate a 'WM_CAPTURECHANGED' message.
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-08-18  Modified: 2016-08-18	//
//																																	//
//	Result: Returns TRUE if successful.  Otherwise returns FALSE.												//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

bool SWOT_DlgSetWndOnTop::SetLastDrawnFrame( HWND hwndUnderMouse )
{
	bool	bStatus = FALSE;
	HWND	hwndParent;
	HDC	hdcParent;
	RECT	rectFrame;

//---------------------------------------------------------------------------------------------------

	if ( hwndUnderMouse != 0 )
	{
		if ( ((hwndParent = GetChildWndRectRelToParent( hwndUnderMouse, &rectFrame )) != 0) &&
			  (hwndParent != m_hWnd) && ((hdcParent = ::GetDCEx( hwndParent, 0, DCX_PARENTCLIP )) != 0) )
		{
			InvertFrame( hdcParent, &rectFrame );
			::ReleaseDC( hwndParent, hdcParent );
			m_hwndLastRectDrawn = hwndUnderMouse;
			bStatus = TRUE;
		}
	}

//---------------------------------------------------------------------------------------------------

	return( bStatus );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-08-18  Modified: 2016-08-18	//
//																																	//
//	Result: Returns TRUE if successful.  Otherwise returns FALSE.												//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

bool SWOT_DlgSetWndOnTop::ClearLastDrawnFrame()
{
	bool	bStatus = FALSE;
	HWND	hwndParent;
	HDC	hdcParent;
	RECT	rectFrame;

//---------------------------------------------------------------------------------------------------

	if ( m_hwndLastRectDrawn != 0 )
	{
		if ( ((hwndParent = GetChildWndRectRelToParent( m_hwndLastRectDrawn, &rectFrame )) != 0) &&
			  (hwndParent != m_hWnd) && ((hdcParent = ::GetDCEx( hwndParent, 0, DCX_PARENTCLIP )) != 0) )
		{
			InvertFrame( hdcParent, &rectFrame );
			::ReleaseDC( hwndParent, hdcParent );
			bStatus = TRUE;
		}

		m_hwndLastRectDrawn = 0;
	}

//---------------------------------------------------------------------------------------------------

	return( bStatus );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-06-18  Modified: 2016-06-26	//
//																																	//
//	Purpose:																														//
//																																	//
//	Result: Returns TRUE if the mouse position is over the area.  Otherwise returns FALSE.				//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

bool SWOT_DlgSetWndOnTop::IsMouseOver_TargetIconCtrl( const int cnPosX, const int cnPosY ) const
{
	bool	bIsMouseOver = FALSE;

	if ( (cnPosX >= rectTargetIcon.left) && (cnPosX < rectTargetIcon.right) &&
		  (cnPosY >= rectTargetIcon.top) && (cnPosY < rectTargetIcon.bottom) )
	{
		bIsMouseOver = TRUE;
	}

	return( bIsMouseOver );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-11  Modified: 2016-08-12	//
//																																	//
//	Purpose:																														//
//																																	//
//	Result: Returns from the popup menu the selected menu item Id.												//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

int SWOT_DlgSetWndOnTop::ProcessPopupMenu()
{
	SWOT_App		  *pThisApp					= SWOT_GetGlobalApp();
	bool				bStatus					= FALSE;
	bool				bAddSeparator			= FALSE;
	HMENU				hMenuPopup				= 0;
	int				nIconCX					= JCH_Max( 16, ::GetSystemMetrics( SM_CXMENUCHECK ) );
	int				nIconCY					= JCH_Max( 16, ::GetSystemMetrics( SM_CYMENUCHECK ) );
	JCH_Pixel		pixMenuBgColor			= JCH_PixelFromColorRef( ::GetSysColor( COLOR_MENU ) );
	HBITMAP			hbitmapSaveFile = 0;
	HBITMAP			hbitmapNewShortcut = 0;
	HBITMAP			hbitmapAbout	 = 0;
	HBITMAP			hbitmapExit		 = 0;
	HICON				hiconTmp;
	int				nRtnValue;
	CRect				rectBtn;
	CPoint			pointScreenMouse;

//---------------------------------------------------------------------------------------------------

	::GetWindowRect( ::GetDlgItem( m_hWnd, IDOK ), &rectBtn );		//	Menu button.
	pointScreenMouse.x = (rectBtn.left + (rectBtn.Width()  / 2)); 
	pointScreenMouse.y = (rectBtn.top  + (rectBtn.Height() / 2)); 

//===================================================================================================

	FOREVER
	{
		if ( (hMenuPopup = ::CreatePopupMenu()) == 0 ) break;

		//------------------------------------------------

		if ( ::AppendMenu( hMenuPopup, (MFS_ENABLED | MFT_STRING), IDM_SaveCurSettings, SWOT_Menu_SaveCurSettings ) == 0 ) break;

		if ( (hiconTmp = (HICON)::LoadImage( pThisApp->m_hInstance,
				MAKEINTRESOURCE( SWOT_App::iidirSaveCurSettings ), IMAGE_ICON, nIconCX, nIconCY, LR_DEFAULTCOLOR )) != 0 )
		{
			if ( (hbitmapSaveFile = SWOT_Create32BitsBitmapFrom32BitsIcon( hiconTmp, pixMenuBgColor )) != 0 )
			{
				::SetMenuItemBitmaps( hMenuPopup, IDM_SaveCurSettings, MF_BYCOMMAND, hbitmapSaveFile, hbitmapSaveFile );
			}

			::DestroyIcon( hiconTmp );
			hiconTmp = 0;
		}

		bAddSeparator = TRUE;

		//

		if ( ::AppendMenu( hMenuPopup, (MFS_ENABLED | MFT_STRING), IDM_CreateDesktopShortcut, SWOT_Menu_CreateDesktopShortcut ) == 0 ) break;

		if ( (hiconTmp = (HICON)::LoadImage( pThisApp->m_hInstance,
				MAKEINTRESOURCE( SWOT_App::iidirNewShortcut ), IMAGE_ICON, nIconCX, nIconCY, LR_DEFAULTCOLOR )) != 0 )
		{
			if ( (hbitmapNewShortcut = SWOT_Create32BitsBitmapFrom32BitsIcon( hiconTmp, pixMenuBgColor )) != 0 )
			{
				::SetMenuItemBitmaps( hMenuPopup, IDM_CreateDesktopShortcut, MF_BYCOMMAND, hbitmapNewShortcut, hbitmapNewShortcut );
			}

			::DestroyIcon( hiconTmp );
			hiconTmp = 0;
		}

		bAddSeparator = TRUE;

		//------------------------------------------------

		if ( bAddSeparator && (bAddSeparator = (AppendMenu( hMenuPopup, (MFS_ENABLED | MFT_SEPARATOR), 0, 0 ) == 0)) ) break;

		//

		if ( ::AppendMenu( hMenuPopup, (MFS_ENABLED | MFT_STRING), IDM_About, SWOT_Menu_About ) == 0 ) break;

		if ( (hiconTmp = (HICON)::LoadImage( pThisApp->m_hInstance,
				MAKEINTRESOURCE( SWOT_App::iidirAbout ), IMAGE_ICON, nIconCX, nIconCY, LR_DEFAULTCOLOR )) != 0 )
		{
			if ( (hbitmapAbout = SWOT_Create32BitsBitmapFrom32BitsIcon( hiconTmp, pixMenuBgColor )) != 0 )
			{
				::SetMenuItemBitmaps( hMenuPopup, IDM_About, MF_BYCOMMAND, hbitmapAbout, hbitmapAbout );
			}

			::DestroyIcon( hiconTmp );
			hiconTmp = 0;
		}

		bAddSeparator = TRUE;

		//------------------------------------------------

		if ( bAddSeparator && (bAddSeparator = (AppendMenu( hMenuPopup, (MFS_ENABLED | MFT_SEPARATOR), 0, 0 ) == 0)) ) break;

		//

		if ( ::AppendMenu( hMenuPopup, (MFS_ENABLED | MFT_STRING), IDM_Exit, SWOT_Menu_Exit ) == 0 ) break;

		if ( (hiconTmp = (HICON)::LoadImage( pThisApp->m_hInstance,
				MAKEINTRESOURCE( SWOT_App::iidirOnOff ), IMAGE_ICON, nIconCX, nIconCY, LR_DEFAULTCOLOR )) != 0 )
		{
			if ( (hbitmapExit = SWOT_Create32BitsBitmapFrom32BitsIcon( hiconTmp, pixMenuBgColor )) != 0 )
			{
				::SetMenuItemBitmaps( hMenuPopup, IDM_Exit, MF_BYCOMMAND, hbitmapExit, hbitmapExit );
			}

			::DestroyIcon( hiconTmp );
			hiconTmp = 0;
		}

		bAddSeparator = TRUE;

		//------------------------------------------------

		if ( bAddSeparator && (bAddSeparator = (AppendMenu( hMenuPopup, (MFS_ENABLED | MFT_SEPARATOR), 0, 0 ) == 0)) ) break;

		//

		if ( AppendMenu( hMenuPopup, (MFS_ENABLED | MFT_STRING), IDM_CloseMenu, SWOT_Menu_CloseMenu ) == 0 ) break;

		bAddSeparator = TRUE;

		//------------------------------------------------

		bStatus = TRUE;
		break;
	}

//===================================================================================================

	if ( !bStatus )
	{
		nRtnValue = IDM_Error;
	}

	//------------------------------------------------

	else
	{
		nRtnValue = (int)::TrackPopupMenuEx( hMenuPopup, (TPM_LEFTALIGN | TPM_TOPALIGN | TPM_RETURNCMD | TPM_RIGHTBUTTON | TPM_NONOTIFY),
														 pointScreenMouse.x, pointScreenMouse.y, m_hWnd, 0 );
	}

//===================================================================================================

	if ( hbitmapSaveFile != 0 )
	{
		::DeleteObject( hbitmapSaveFile );
		hbitmapSaveFile = 0;
	}

	if ( hbitmapNewShortcut != 0 )
	{
		::DeleteObject( hbitmapNewShortcut );
		hbitmapNewShortcut = 0;
	}

	if ( hbitmapAbout != 0 )
	{
		::DeleteObject( hbitmapAbout );
		hbitmapAbout = 0;
	}

	if ( hbitmapExit != 0 )
	{
		::DeleteObject( hbitmapExit );
		hbitmapExit = 0;
	}

	//------------------------------------------------

	if ( hMenuPopup != 0 )
	{
		::DestroyMenu( hMenuPopup );
		hMenuPopup = 0;
	}

//===================================================================================================

	if ( nRtnValue == IDM_SaveCurSettings )
	{
		bool		bStatus = TRUE;
		CString	strMainWindow;

		//------------------------------------------------

		strMainWindow.Format( _T("%s\\%s"), (LPCTSTR)pThisApp->m_strRegKey__AppKeyName, SWOT_REG_KEY__MainWindow );

		if ( !SWOT_SaveScreenInfoToRegistry( strMainWindow, m_hWnd ) ) bStatus = FALSE;

		//

		if ( SWOT_SaveMiscSettingsToRegistry( m_bIsDlgTopMost, m_bIsAutoFindRootParent, m_bIsDrawInvertedFrame ) != ERROR_SUCCESS ) bStatus = FALSE;

		//------------------------------------------------

		::PlaySound( MAKEINTRESOURCE( (bStatus ? IDR_SETTINGS_SAVED_WAVE : IDR_UHOH_MSG_WAVE) ),
						 pThisApp->m_hInstance, (SND_ASYNC | SND_RESOURCE | SND_NODEFAULT) );
	}

//---------------------------------------------------------------------------------------------------

	else if ( nRtnValue == IDM_CreateDesktopShortcut )
	{
		pThisApp->CreateDesktopShortcut();
	}

//---------------------------------------------------------------------------------------------------

	else if ( nRtnValue == IDM_About )
	{
		if ( ::DialogBox( pThisApp->m_hInstance, MAKEINTRESOURCE( IDD_ABOUT ), m_hWnd, DlgAboutProc ) == -1 )
		{
			::MessageBeep( MB_ICONHAND );
		}
	}

//---------------------------------------------------------------------------------------------------

	else if ( nRtnValue == IDM_Exit )
	{
		::SendMessage( m_hWnd, WM_COMMAND, MAKEWPARAM( IDC_Cmd__Exit, 0 ), 0 );
	}

//---------------------------------------------------------------------------------------------------

	else	//	if ( (nRtnValue == IDM_CloseMenu) || (nRtnValue == IDM_NoMenu) || (nRtnValue == IDM_Error) )
	{
		//	Do nothing.
 	}

//===================================================================================================

	return( nRtnValue );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-12  Modified: 2016-08-20	//
//																																	//
//	Purpose:																														//
//																																	//
//	Result: Returns TRUE if successful.  Otherwise returns FALSE.												//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

bool SWOT_DlgSetWndOnTop::CopyInfoToClipboard()
{
	bool		bStatus = TRUE;
	int		nTitle, nClass, nDescriptor, nIdentifier, nStyle, nStyleEx, nParent, nRect, nAlign, nIndex;
	CString	strTitle, strClass, strDescriptor, strIdentifier, strStyle, strStyleEx, strParent, strRect, strSeparator, strData;
	
//---------------------------------------------------------------------------------------------------

	try
	{
		strTitle		  = SWOT_GetWindowText( GetDlgItem( IDC_Title_TX		) );
		strClass		  = SWOT_GetWindowText( GetDlgItem( IDC_Class_TX		) );
		strDescriptor = SWOT_GetWindowText( GetDlgItem( IDC_Descriptor_TX ) );
		strIdentifier = SWOT_GetWindowText( GetDlgItem( IDC_Identifier_TX ) );
		strStyle		  = SWOT_GetWindowText( GetDlgItem( IDC_Style_TX		) );
		strStyleEx	  = SWOT_GetWindowText( GetDlgItem( IDC_ExtStyle_TX	) );
		strParent	  = SWOT_GetWindowText( GetDlgItem( IDC_Parent_TX		) );
		strRect		  = SWOT_GetWindowText( GetDlgItem( IDC_Rectangle_TX	) );

		strTitle.Remove(		 _T(':') );			strTitle.Trim();
		strClass.Remove(		 _T(':') );			strClass.Trim();
		strDescriptor.Remove( _T(':') );			strDescriptor.Trim();
		strIdentifier.Remove( _T(':') );			strIdentifier.Trim();
		strStyle.Remove(		 _T(':') );			strStyle.Trim();
		strStyleEx.Remove(	 _T(':') );			strStyleEx.Trim();
		strParent.Remove(		 _T(':') );			strParent.Trim();
		strRect.Remove(		 _T(':') );			strRect.Trim();

		//------------------------------------------------

		nTitle		= strTitle.GetLength();
		nClass		= strClass.GetLength();
		nDescriptor	= strDescriptor.GetLength();
		nIdentifier	= strIdentifier.GetLength();
		nStyle		= strStyle.GetLength();
		nStyleEx		= strStyleEx.GetLength();
		nParent		= strParent.GetLength();
		nRect			= strRect.GetLength();

		//------------------------------------------------

		nAlign = nTitle;

		if ( nClass		  > nAlign ) nAlign = nClass;
		if ( nDescriptor > nAlign ) nAlign = nDescriptor;
		if ( nIdentifier > nAlign ) nAlign = nIdentifier;
		if ( nStyle		  > nAlign ) nAlign = nStyle;
		if ( nStyleEx	  > nAlign ) nAlign = nStyleEx;
		if ( nParent	  > nAlign ) nAlign = nParent;
		if ( nRect		  > nAlign ) nAlign = nRect;

		//------------------------------------------------

		for( nIndex = nTitle;		(nIndex < nAlign); nIndex++ ) strTitle		  += _T(" ");
		for( nIndex = nClass;		(nIndex < nAlign); nIndex++ ) strClass		  += _T(" ");
		for( nIndex = nDescriptor; (nIndex < nAlign); nIndex++ ) strDescriptor += _T(" ");
		for( nIndex = nIdentifier; (nIndex < nAlign); nIndex++ ) strIdentifier += _T(" ");
		for( nIndex = nStyle;		(nIndex < nAlign); nIndex++ ) strStyle		  += _T(" ");
		for( nIndex = nStyleEx;		(nIndex < nAlign); nIndex++ ) strStyleEx	  += _T(" ");
		for( nIndex = nParent;		(nIndex < nAlign); nIndex++ ) strParent	  += _T(" ");
		for( nIndex = nRect;			(nIndex < nAlign); nIndex++ ) strRect		  += _T(" ");

		strSeparator = _T(" :  ");

		strTitle		  += (strSeparator + SWOT_GetWindowText( GetDlgItem( IDC_Title_ED		  ) ));
		strClass		  += (strSeparator + SWOT_GetWindowText( GetDlgItem( IDC_Class_ED		  ) ));
		strDescriptor += (strSeparator + SWOT_GetWindowText( GetDlgItem( IDC_Descriptor_ED ) ));
		strIdentifier += (strSeparator + SWOT_GetWindowText( GetDlgItem( IDC_Identifier_ED ) ));
		strStyle		  += (strSeparator + SWOT_GetWindowText( GetDlgItem( IDC_Style_ED		  ) ));
		strStyleEx	  += (strSeparator + SWOT_GetWindowText( GetDlgItem( IDC_ExtStyle_ED	  ) ));
		strParent	  += (strSeparator + SWOT_GetWindowText( GetDlgItem( IDC_Parent_ED	  ) ));
		strRect		  += (strSeparator + SWOT_GetWindowText( GetDlgItem( IDC_Rectangle_ED  ) ));

//---------------------------------------------------------------------------------------------------

		strData = strTitle;
		strData += _T("\r\n");

		strData += strClass;
		strData += _T("\r\n");

		strData += strDescriptor;
		strData += _T("\r\n");

		strData += strIdentifier;
		strData += _T("\r\n");

		strData += strStyle;
		strData += _T("\r\n");

		strData += strStyleEx;
		strData += _T("\r\n");

		strData += strParent;
		strData += _T("\r\n");

		strData += strRect;
		strData += _T("\r\n");
	}

//===================================================================================================

	catch( CMemoryException *pException )
	{
		bStatus = FALSE;
		pException->Delete();
	}

//===================================================================================================

	if ( bStatus ) bStatus = SWOT_GetGlobalApp()->CopyTDSTToClipboard( strData, 0, 0, strData.GetLength(), -1, m_hWnd );

	return( bStatus );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-08-08  Modified: 2016-08-19	//
//																																	//
//	Purpose:																														//
//																																	//
//	Result: Returns the handle of the window under the mouse or 0.												//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK SWOT_DlgSetWndOnTop::GetWndFromPointProc( HWND hwnd, LPARAM lParam )
{
	bool		bMoreChildWindow = TRUE;
	GWFPP	  *pEFD				  = (GWFPP *)lParam;
	CRect		rectChild;
	TCHAR		szClassName[257];		//	See 'WNDCLASS.lpszClassName' for details.

//---------------------------------------------------------------------------------------------------

	if ( ::IsWindowVisible( hwnd ) && (!pEFD->m_bExcludeDisabledWindow || ::IsWindowEnabled( hwnd )) )
	{
		::GetWindowRect( hwnd, &rectChild );
		::ScreenToClient( pEFD->m_hwndParent, (LPPOINT)&rectChild );
		::ScreenToClient( pEFD->m_hwndParent, ((LPPOINT)&rectChild) + 1 );

		rectChild &= pEFD->m_rectClient;

		if ( rectChild.PtInRect( pEFD->m_pointParentMouse ) )
		{
			pEFD->m_hwndChildUnderMouse = hwnd;
			_tcsEmpty( szClassName );

			if ( (::GetClassName( hwnd, szClassName, _countof( szClassName ) ) == 0) || (_tcsicmp( szClassName, WC_BUTTON ) != 0) ||
				  ((::GetWindowLongPtr( hwnd, GWL_STYLE ) & BS_GROUPBOX) == 0) )
			{
				if ( !pEFD->m_bScanAllChildWnd ) bMoreChildWindow = FALSE;
			}
		}
	}

//---------------------------------------------------------------------------------------------------

	return( bMoreChildWindow );
}

//===================================================================================================

HWND SWOT_DlgSetWndOnTop::GetWndFromPoint( POINT pointScreenMouse, const bool cbExcludeDisabledWindow, const bool cbCheckDescendantWindow )
{
	HWND			hwndUnderMouse = 0;
	class GWFPP	EnumFnctData;

//---------------------------------------------------------------------------------------------------

	hwndUnderMouse = ::WindowFromPoint( pointScreenMouse );

	if ( hwndUnderMouse != 0 ) hwndUnderMouse = ::GetAncestor( hwndUnderMouse, GA_ROOT );

	if ( (hwndUnderMouse != 0) && (!cbExcludeDisabledWindow || ::IsWindowEnabled( hwndUnderMouse )) )
	{
		FOREVER
		{
			EnumFnctData.Initialize();
			EnumFnctData.m_pointParentMouse = pointScreenMouse;
			::ScreenToClient( hwndUnderMouse, &EnumFnctData.m_pointParentMouse );

			EnumFnctData.m_hwndParent = hwndUnderMouse;
			EnumFnctData.m_bExcludeDisabledWindow = cbExcludeDisabledWindow;
			::GetClientRect( hwndUnderMouse, &EnumFnctData.m_rectClient );

			::EnumChildWindows( hwndUnderMouse, GetWndFromPointProc, (LPARAM)&EnumFnctData );

			if ( EnumFnctData.m_hwndChildUnderMouse != 0 )
			{
				hwndUnderMouse = EnumFnctData.m_hwndChildUnderMouse;
				
				if ( !cbCheckDescendantWindow ) break;
			}
			else break;
		}
	}
	else hwndUnderMouse = 0; 

//---------------------------------------------------------------------------------------------------

	return( hwndUnderMouse );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-08-11  Modified: 2016-08-11	//
//																																	//
//	Purpose:																														//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////
	
void SWOT_DlgSetWndOnTop::InvertFrame( HDC hdcWnd, LPRECT lpRect )
{
	int		nPosX = lpRect->left;
	int		nPosY = lpRect->top;
	int		nCX	= (lpRect->right - lpRect->left);
	int		nCY	= (lpRect->bottom - lpRect->top);
	POINT		pointOld;
	int		nROP2Old;
	HPEN		hpenOld;

//---------------------------------------------------------------------------------------------------

	::MoveToEx( hdcWnd, 0, 0, &pointOld );
	hpenOld = (HPEN)::SelectObject( hdcWnd, ::GetStockObject( BLACK_PEN ) );
	nROP2Old = ::SetROP2( hdcWnd, R2_NOT );

//---------------------------------------------------------------------------------------------------

	if ( nCX >= 1 )
	{
		if ( nCY >= 1 )
		{
			::MoveToEx( hdcWnd, nPosX, nPosY, NULL );
			::LineTo( hdcWnd, (nPosX + nCX), nPosY );
		}

		if ( nCY >= 2 )
		{
			::MoveToEx( hdcWnd, nPosX, (nPosY + nCY - 1), NULL );
			::LineTo( hdcWnd, (nPosX + nCX), (nPosY + nCY - 1) );
		}

		if ( nCY >= 3 )
		{
			::MoveToEx( hdcWnd, nPosX, (nPosY + 1), NULL );
			::LineTo( hdcWnd, (nPosX + nCX), (nPosY + 1) );
		}

		if ( nCY >= 4 )
		{
			::MoveToEx( hdcWnd, nPosX, (nPosY + nCY - 2), NULL );
			::LineTo( hdcWnd, (nPosX + nCX), (nPosY + nCY - 2) );
		}

		if ( nCY >= 5 )
		{
			::MoveToEx( hdcWnd, nPosX, (nPosY + 2), NULL );
			::LineTo( hdcWnd, (nPosX + nCX), (nPosY + 2) );
		}

		if ( nCY >= 6 )
		{
			::MoveToEx( hdcWnd, nPosX, (nPosY + nCY - 3), NULL );
			::LineTo( hdcWnd, (nPosX + nCX), (nPosY + nCY - 3) );
		}
	}

	//------------------------------------------------

	if ( nCY >= 7 )
	{
		if ( nCX >= 1 )
		{
			::MoveToEx( hdcWnd, nPosX, (nPosY + 3), NULL );
			::LineTo( hdcWnd, nPosX, (nPosY + nCY - 3) );
		}

		if ( nCX >= 2 )
		{
			::MoveToEx( hdcWnd, (nPosX + nCX - 1), (nPosY + 3), NULL );
			::LineTo( hdcWnd, (nPosX + nCX - 1), (nPosY + nCY - 3) );
		}

		if ( nCX >= 3 )
		{
			::MoveToEx( hdcWnd, (nPosX + 1), (nPosY + 3), NULL );
			::LineTo( hdcWnd, (nPosX + 1), (nPosY + nCY - 3) );
		}

		if ( nCX >= 4 )
		{
			::MoveToEx( hdcWnd, (nPosX + nCX - 2), (nPosY + 3), NULL );
			::LineTo( hdcWnd, (nPosX + nCX - 2), (nPosY + nCY - 3) );
		}

		if ( nCX >= 5 )
		{
			::MoveToEx( hdcWnd, (nPosX + 2), (nPosY + 3), NULL );
			::LineTo( hdcWnd, (nPosX + 2), (nPosY + nCY - 3) );
		}

		if ( nCX >= 6 )
		{
			::MoveToEx( hdcWnd, (nPosX + nCX - 3), (nPosY + 3), NULL );
			::LineTo( hdcWnd, (nPosX + nCX - 3), (nPosY + nCY - 3) );
		}
	}

//---------------------------------------------------------------------------------------------------

	::SetROP2( hdcWnd, nROP2Old );
	::SelectObject( hdcWnd, hpenOld );
	::MoveToEx( hdcWnd, pointOld.x, pointOld.y, NULL );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-08-11  Modified: 2016-08-20	//
//																																	//
//	Purpose:																														//
//																																	//
// 'lpRect': It will contain the rectangle of 'hwndChild' relative to the returned window handle.	//
//																																	//
//	Result: Returns the handle to the first window without the 'WS_CHILD' flag.							//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

HWND SWOT_DlgSetWndOnTop::GetChildWndRectRelToParent( HWND hwndChild, LPRECT lpRect )
{
	HWND		hwndParent = 0;
	HWND		hwndTmpParent;
	LONG_PTR	npStyle;

//---------------------------------------------------------------------------------------------------

	if ( ::IsWindow( hwndChild ) )
	{
		::SetLastError( ERROR_SUCCESS );	// Very important.  See documentations about 'GetWindowLongPtr()' and 'SetWindowLongPtr()'.
		npStyle = ::GetWindowLongPtr( hwndChild, GWL_STYLE );

		if ( (npStyle != 0) || (::GetLastError() == ERROR_SUCCESS) )
		{
			if ( ((npStyle & WS_POPUP) == WS_POPUP) || ((npStyle & WS_CHILD) != WS_CHILD) )	//	Top parent?
			{
				hwndParent = hwndChild;
				::GetClientRect( hwndParent, lpRect );
			}
			else	//	Child window.
			{
				for( hwndTmpParent = ::GetParent( hwndChild ); (hwndTmpParent != 0); hwndTmpParent = ::GetParent( hwndTmpParent ) )
				{
					::SetLastError( ERROR_SUCCESS );	// Very important.  See documentations about 'GetWindowLongPtr()' and 'SetWindowLongPtr()'.
					npStyle = ::GetWindowLongPtr( hwndTmpParent, GWL_STYLE );

					if ( (npStyle != 0) || (::GetLastError() == ERROR_SUCCESS) )
					{
						if ( ((npStyle & WS_POPUP) == WS_POPUP) || ((npStyle & WS_CHILD) != WS_CHILD) )	//	Top parent reached?
						{
							hwndParent = hwndTmpParent;
							::GetWindowRect( hwndChild, lpRect );
							::ScreenToClient( hwndParent,  (LPPOINT)lpRect );
							::ScreenToClient( hwndParent, ((LPPOINT)lpRect) + 1 );
							break;
						}
					}
					else break;		//	Error with 'GetWindowLongPtr()'. 
				}
			}
		}
	}

//---------------------------------------------------------------------------------------------------

	if ( hwndParent == 0 ) lpRect->left = lpRect->top = lpRect->right = lpRect->bottom = 0;

	return( hwndParent );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-03-16  Modified: 2016-08-08	//
//																																	//
//	Purpose:	Message handler for the 'IDD_ABOUT' dialog box.														//
//																																	//
//	Result:																														//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

INT_PTR CALLBACK SWOT_DlgSetWndOnTop::DlgAboutProc( HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	INT_PTR	npRtnValue = FALSE;	// Set to "message not processed" by default.

//---------------------------------------------------------------------------------------------------

	switch( uMsg )
	{

/////////////////////////////////////////////////////////////////////////////////////////////////////

	case WM_INITDIALOG:
		{
			SWOT_App   *pThisApp	= SWOT_GetGlobalApp();
			TCHAR			szFileVersion[SWOT_MINSTRBUF__VERSION];
			CString		strText;

			SWOT_SHCreateVersionNumber( szFileVersion, pThisApp->m_un64AppFileVersion );
			strText.Format( SWOT_FmtMsg_AboutVersion, szFileVersion );
			::SetWindowText( ::GetDlgItem( hwndDlg, IDC_NAME_AND_VERSION_TX ), (LPCTSTR)strText );

//---------------------------------------------------------------------------------------------------

			::SendMessage( ::GetDlgItem( hwndDlg, IDOK ), BM_SETIMAGE, IMAGE_ICON, (LPARAM)::LoadImage( pThisApp->m_hInstance,
								MAKEINTRESOURCE( IDI_CLOSE ), IMAGE_ICON, 32, 32, LR_DEFAULTCOLOR ) );

			::SendMessage( hwndDlg, WM_SETICON, ICON_SMALL, (LPARAM)::LoadImage( pThisApp->m_hInstance,
								MAKEINTRESOURCE( IDI_ABOUT ), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR ) );

			SWOT_CenterWindow( hwndDlg, ::GetParent( hwndDlg ) );
			::SendMessage( hwndDlg, WM_NEXTDLGCTL, (WPARAM)::GetDlgItem( hwndDlg, IDOK ), MAKELPARAM( TRUE, 0 ) );
			npRtnValue = (INT_PTR)FALSE;	//	Focus has been set manually.
			break;
		}

/////////////////////////////////////////////////////////////////////////////////////////////////////

	case WM_COMMAND:
		{
			int	nCommandId	= LOWORD( wParam );
			int	nNotifyCode	= HIWORD( wParam );

			if ( (nCommandId == IDOK) || (nCommandId == IDCANCEL) )
			{
				::EndDialog( hwndDlg, nCommandId );
				npRtnValue = (INT_PTR)TRUE;
			}
			break;
		}

/////////////////////////////////////////////////////////////////////////////////////////////////////

	case WM_DESTROY:
		{
			HICON		hiconTmp;

			if ( (hiconTmp = (HICON)::SendMessage( ::GetDlgItem( hwndDlg, IDOK ), BM_GETIMAGE, IMAGE_ICON, 0 )) != 0 )
				::DestroyIcon( hiconTmp );

			if ( (hiconTmp = (HICON)::SendMessage( hwndDlg, WM_GETICON, ICON_SMALL, 0 )) != 0 )
				::DestroyIcon( hiconTmp );

			npRtnValue = (INT_PTR)TRUE;
			break;
		}

/////////////////////////////////////////////////////////////////////////////////////////////////////

	case WM_NOTIFY:
		{
			LRESULT	npResult = 0;
			LPNMHDR	pNMHdr	= (LPNMHDR)lParam;

//---------------------------------------------------------------------------------------------------

			if ( ((pNMHdr->code == NM_RETURN) || (pNMHdr->code == NM_CLICK)) && 
				  (((pNMHdr->hwndFrom == ::GetDlgItem( hwndDlg, IDC_WEBSITE_SL1 )) && (pNMHdr->idFrom == IDC_WEBSITE_SL1)) ||
				   ((pNMHdr->hwndFrom == ::GetDlgItem( hwndDlg, IDC_WEBSITE_SL2 )) && (pNMHdr->idFrom == IDC_WEBSITE_SL2))) )
			{
				PNMLINK	pNMLink = (PNMLINK)pNMHdr;
				char		szUrl[L_MAX_URL_LENGTH];

				if ( WideCharToMultiByte( CP_ACP, 0, pNMLink->item.szUrl, -1, szUrl, _countof( szUrl ), 0, 0 ) != 0 )
					ThisApp.BrowseWebpageLink( szUrl, hwndDlg );

				npRtnValue = SetDlgMsgResult( hwndDlg, WM_NOTIFY, npResult );
			}

			break;
		}

/////////////////////////////////////////////////////////////////////////////////////////////////////

	}

//---------------------------------------------------------------------------------------------------

	return( npRtnValue );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-06-18  Modified: 2016-07-11	//
//																																	//
//	Purpose:																														//
//																																	//
//	Result: If DialogBoxParam() fails then the return value will be -1 or 0 and GetLastError()		//
//			  will return 'ERROR_BAD_ARGUMENTS'.  In such case verify the value of 'm_hInstance',		//
//			  'm_strTemplate' and 'm_hwndParent'																		//
//																																	//
//			  If the function is successful then the return value can be any value allowed by this		//
//			  specific dialog box implementation.																		//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

INT_PTR SWOT_DlgSetWndOnTop::DoModal()
{
	LPCTSTR	pcszTemplate =	(LPCTSTR)m_strTemplate;

//---------------------------------------------------------------------------------------------------

	m_bModalMode = TRUE;

	if ( pcszTemplate[0] == _T('#') )
	{
		unsigned int	unDlgResId;

		if ( _stscanf( &pcszTemplate[1], _T("%u"), &unDlgResId ) == 1 ) pcszTemplate = MAKEINTRESOURCE( unDlgResId );
		else																				 pcszTemplate = MAKEINTRESOURCE( 0 );
	}

//	m_npResult = ::DialogBoxParam( m_hInstance, m_strTemplate, m_hwndParent, DispatchMsgProcedure, (LPARAM)this );
	m_npResult = ::DialogBoxParam( m_hInstance, pcszTemplate, m_hwndParent, DispatchMsgProcedure, (LPARAM)this );

	if ( ((m_npResult == -1) || (m_npResult == 0)) && (::GetLastError() != ERROR_SUCCESS) )
	{
		::SetLastError( ERROR_BAD_ARGUMENTS );	//	Must be called last just before returning because
	}														//	 it may be changed again by other functions.

//---------------------------------------------------------------------------------------------------

	return( m_npResult );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-06-18  Modified: 2016-06-18	//
//																																	//
//	Purpose:	Dialog message dispatcher.																					//
//																																	//
//	Result:																														//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

INT_PTR CALLBACK SWOT_DlgSetWndOnTop::DispatchMsgProcedure( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	SWOT_DlgSetWndOnTop *pDlg;
	INT_PTR					npRtnValue;
	DWORD						dwCursorPos;
	MSG					  *pmsgBkp, msgTmp;

/////////////////////////////////////////////////////////////////////////////////////////////////////

	if ( (pDlg = (SWOT_DlgSetWndOnTop *)::GetWindowLongPtr( hDlg, GWLP_USERDATA )) == 0 )
	{
		if ( uMsg == WM_INITDIALOG )
		{
			if ( ((pDlg = (SWOT_DlgSetWndOnTop *)lParam) != 0) && pDlg->Attach( hDlg ) )
			{
				::SetWindowLongPtr( pDlg->m_hWnd, GWLP_USERDATA, (LONG_PTR)pDlg );
//				pDlg->m_bIsTrackingMouseLeaveEnabled = FALSE;
			}
			else	//	Never supposed to happen in the release version if there is no bug in the application.
			{																												
				ASSERT( 0 );		//	We cannot call EndDialog() or DestroyWindow() since
				return( TRUE );	//	 we have no idea if we are in a modal or modeless dialog.
			}
		}

//---------------------------------------------------------------------------------------------------

		else	// Process messages received before WM_INITDIALOG (Normally only WM_SETFONT),
		{		// and also process messages received after WM_NCDESTROY (Normally none).
			return( FALSE );	// Message not processed.
		}
	}

/////////////////////////////////////////////////////////////////////////////////////////////////////

	dwCursorPos = ::GetMessagePos();
	pmsgBkp		= pDlg->m_pCurMsg;		//	Save current message to support recursive calls.

	pDlg->m_pCurMsg			 = &msgTmp;	//	Set a new temporary MSG structure.
	pDlg->m_pCurMsg->hwnd	 = hDlg;
	pDlg->m_pCurMsg->message = uMsg;
	pDlg->m_pCurMsg->wParam  = wParam;
	pDlg->m_pCurMsg->lParam  = lParam;
	pDlg->m_pCurMsg->time	 = ::GetMessageTime();
	pDlg->m_pCurMsg->pt.x	 = GET_X_LPARAM( dwCursorPos );
	pDlg->m_pCurMsg->pt.y	 = GET_Y_LPARAM( dwCursorPos );

	npRtnValue = pDlg->Modal_ProcessCurrentMessage();

	pDlg->m_pCurMsg = pmsgBkp;	//	Restore previous message.

/////////////////////////////////////////////////////////////////////////////////////////////////////
	
	if ( uMsg == WM_NCDESTROY )
	{
		::SetWindowLongPtr( pDlg->m_hWnd, GWLP_USERDATA, 0 );
		pDlg->Detach();
	}

/////////////////////////////////////////////////////////////////////////////////////////////////////

	return( npRtnValue );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-06-18  Modified: 2016-07-11	//
//																																	//
//	Purpose:																														//
//																																	//
//	Result: Depends on message processed.																				//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

INT_PTR SWOT_DlgSetWndOnTop::Modal_ProcessCurrentMessage()
{
	switch( m_pCurMsg->message )
	{
	case WM_CAPTURECHANGED:		return( Process_WM_CAPTURECHANGED()	);		break;
	case WM_COMMAND:				return( Process_WM_COMMAND()		   );		break;
	case WM_DESTROY:				return( Process_WM_DESTROY()		   );		break;
	case WM_HELP:					return( Process_WM_HELP()				);		break;
	case WM_INITDIALOG:			return( Process_WM_INITDIALOG()	   );		break;
	case WM_LBUTTONDBLCLK:		return( Process_WM_LBUTTONDBLCLK()  );		break;
	case WM_LBUTTONDOWN:			return( Process_WM_LBUTTONDOWN()	   );		break;
	case WM_LBUTTONUP:			return( Process_WM_LBUTTONUP()	   );		break;
	case WM_MOUSEMOVE:			return( Process_WM_MOUSEMOVE()	   );		break;
	case WM_NCDESTROY:			return( Process_WM_NCDESTROY()	   );		break;
	case WM_SYSCOMMAND:			return( Process_WM_SYSCOMMAND()	   );		break;
	}

//---------------------------------------------------------------------------------------------------

	return( FALSE );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-06-18  Modified: 2016-08-20	//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

INT_PTR SWOT_DlgSetWndOnTop::Process_WM_CAPTURECHANGED()
{
	HWND	hwndNewMouseOwner = (HWND)m_pCurMsg->lParam;

//---------------------------------------------------------------------------------------------------

	if	( hwndNewMouseOwner != m_hWnd )
	{
		if ( m_bIsDrawInvertedFrame && !m_bIsAutoFindRootParent && (m_hwndLastRectDrawn != 0) ) ClearLastDrawnFrame();

		m_bIsMouseCaptured = FALSE;
		SetTargetIcon();
		WiselyEnableWindow( GetDlgItem( IDC_KeepDlgOnTop_CK ), TRUE );
		WiselyEnableWindow( GetDlgItem( IDC_AutoFindRootParent_CK ), TRUE );
		WiselyEnableWindow( GetDlgItem( IDC_DrawInvertedFrame_CK ), !m_bIsAutoFindRootParent );

		WiselyEnableWindow( GetDlgItem( IDOK ), TRUE );		//	See 'Process_WM_LBUTTONDOWN()' for details.
		GotoDlgCtrl( IDOK );
	}

	return( TRUE );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-06-18  Modified: 2016-08-20	//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

INT_PTR SWOT_DlgSetWndOnTop::Process_WM_COMMAND()
{
	bool	bRtnValue	= FALSE;	// Set to "message not processed" by default.
	int	nCommandId	= LOWORD( m_pCurMsg->wParam );
	int	nNotifyCode	= HIWORD( m_pCurMsg->wParam );

/////////////////////////////////////////////////////////////////////////////////////////////////////

	switch( nCommandId )
	{

/////////////////////////////////////////////////////////////////////////////////////////////////////

	case IDC_KeepDlgOnTop_CK:
		{
			if ( nNotifyCode == BN_CLICKED )
			{
				m_bIsDlgTopMost = (::IsDlgButtonChecked( m_hWnd, IDC_KeepDlgOnTop_CK ) == BST_CHECKED);

				::PlaySound( MAKEINTRESOURCE( (m_bIsDlgTopMost ? IDR_CHECKBOX_CHECKED_WAVE : IDR_CHECKBOX_UNCHECKED_WAVE) ),
								 SWOT_GetGlobalApp()->m_hInstance, (SND_ASYNC | SND_RESOURCE | SND_NODEFAULT) );

				::SetWindowPos( m_hWnd, (m_bIsDlgTopMost ? HWND_TOPMOST : HWND_NOTOPMOST), 0, 0, 0, 0, (SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE) );
			}

			bRtnValue = TRUE;
			break;
		}

/////////////////////////////////////////////////////////////////////////////////////////////////////

	case IDC_AutoFindRootParent_CK:
		{
			if ( nNotifyCode == BN_CLICKED )
			{
				m_bIsAutoFindRootParent = (::IsDlgButtonChecked( m_hWnd, IDC_AutoFindRootParent_CK ) == BST_CHECKED);

				::PlaySound( MAKEINTRESOURCE( (m_bIsAutoFindRootParent ? IDR_CHECKBOX_CHECKED_WAVE : IDR_CHECKBOX_UNCHECKED_WAVE) ),
								 SWOT_GetGlobalApp()->m_hInstance, (SND_ASYNC | SND_RESOURCE | SND_NODEFAULT) );

				WiselyEnableWindow( GetDlgItem( IDC_DrawInvertedFrame_CK ), !m_bIsAutoFindRootParent );
				::CheckDlgButton( m_hWnd, IDC_DrawInvertedFrame_CK,
										((m_bIsDrawInvertedFrame && !m_bIsAutoFindRootParent) ? BST_CHECKED : BST_UNCHECKED) );

				SetInfoControls( m_hwndCurSelWnd );
			}

			bRtnValue = TRUE;
			break;
		}

/////////////////////////////////////////////////////////////////////////////////////////////////////

	case IDC_DrawInvertedFrame_CK:
		{
			if ( nNotifyCode == BN_CLICKED )
			{
				m_bIsDrawInvertedFrame = (::IsDlgButtonChecked( m_hWnd, IDC_DrawInvertedFrame_CK ) == BST_CHECKED);

				::PlaySound( MAKEINTRESOURCE( (m_bIsDrawInvertedFrame ? IDR_CHECKBOX_CHECKED_WAVE : IDR_CHECKBOX_UNCHECKED_WAVE) ),
								 SWOT_GetGlobalApp()->m_hInstance, (SND_ASYNC | SND_RESOURCE | SND_NODEFAULT) );
			}

			bRtnValue = TRUE;
			break;
		}

/////////////////////////////////////////////////////////////////////////////////////////////////////

	case IDC_KeepSelWndOnTop_CK:
		{
			if ( nNotifyCode == BN_CLICKED )
			{
				HWND		hwndTopParent, hwndTmpParent;
				bool		bIsWndHandleValid;
				LONG_PTR	npStyle, npExStyle;

				//------------------------------------------------
				//	Verifies if the top parent window handle is still not a child window.

				if ( ((m_hwndCurSelWnd_TopParent != 0) && ::IsWindow( m_hwndCurSelWnd_TopParent )) )
				{
					for( hwndTopParent = hwndTmpParent = m_hwndCurSelWnd_TopParent;
							((hwndTmpParent = ::GetParent( hwndTmpParent )) != 0); hwndTopParent = hwndTmpParent );

					if ( hwndTopParent == m_hwndCurSelWnd_TopParent )
					{
						::SetLastError( ERROR_SUCCESS );	// Very important.  See documentations about 'GetWindowLongPtr()' and 'SetWindowLongPtr()'.
						npStyle = ::GetWindowLongPtr( m_hwndCurSelWnd_TopParent, GWL_STYLE );

						if ( (npStyle != 0) || (::GetLastError() == ERROR_SUCCESS) )
						{
							if ( ((npStyle & WS_POPUP) == WS_POPUP) || ((npStyle & WS_CHILD) != WS_CHILD) )	//	Still a top parent?
							{
								bIsWndHandleValid = TRUE;
							}
							else bIsWndHandleValid = FALSE;
						}
						else bIsWndHandleValid = FALSE;
					}
					else bIsWndHandleValid = FALSE;
				}
				else bIsWndHandleValid = FALSE;

				//------------------------------------------------

				if ( bIsWndHandleValid )
				{
					m_bIsSelWndTopMost = (::IsDlgButtonChecked( m_hWnd, IDC_KeepSelWndOnTop_CK ) == BST_CHECKED);

					if ( ::SetWindowPos( m_hwndCurSelWnd_TopParent, (m_bIsSelWndTopMost ? HWND_TOPMOST : HWND_NOTOPMOST),
												0, 0, 0, 0, (SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE) ) )
					{
						::SetLastError( ERROR_SUCCESS );	// Very important.  See documentations about 'GetWindowLongPtr()' and 'SetWindowLongPtr()'.
						npExStyle = ::GetWindowLongPtr( m_hwndCurSelWnd_TopParent, GWL_EXSTYLE );

						if ( (npExStyle != 0) || (::GetLastError() == ERROR_SUCCESS) )
						{
							bIsWndHandleValid = !(m_bIsSelWndTopMost ^ ((npExStyle & WS_EX_TOPMOST) == WS_EX_TOPMOST));
						}
						else bIsWndHandleValid = FALSE;
					}
					else bIsWndHandleValid = FALSE;
				}

				//------------------------------------------------

				if ( bIsWndHandleValid )
				{
					SetInfoControls( m_hwndCurSelWnd );
					::PlaySound( MAKEINTRESOURCE( (m_bIsSelWndTopMost ? IDR_CHECKBOX_CHECKED_WAVE : IDR_CHECKBOX_UNCHECKED_WAVE) ),
									 SWOT_GetGlobalApp()->m_hInstance, (SND_ASYNC | SND_RESOURCE | SND_NODEFAULT) );
				}
				else
				{
					ClearInfoControls();	//	This function set 'm_bIsSelWndTopMost' to FALSE and 'm_hwndCurSelWnd' and 'm_hwndCurSelWnd_TopParent' to 0.
					::PlaySound( MAKEINTRESOURCE( IDR_UHOH_MSG_WAVE ), SWOT_GetGlobalApp()->m_hInstance, (SND_ASYNC | SND_RESOURCE | SND_NODEFAULT) );
				}
			}

//---------------------------------------------------------------------------------------------------

			bRtnValue = TRUE;
			break;
		}

/////////////////////////////////////////////////////////////////////////////////////////////////////

	case IDC_CopyInfoToClipboard_BT:
		{
			if ( nNotifyCode == BN_CLICKED )
			{
				::PlaySound( MAKEINTRESOURCE( (CopyInfoToClipboard() ? IDR_COPY_WAVE : IDR_UHOH_MSG_WAVE) ),
								 SWOT_GetGlobalApp()->m_hInstance, (SND_ASYNC | SND_RESOURCE | SND_NODEFAULT) );
			}

			bRtnValue = TRUE;
			break;
		}

/////////////////////////////////////////////////////////////////////////////////////////////////////

	case IDOK:
		{
			if ( !m_bIsMouseCaptured )
			{
				if ( GetFocus() == GetDlgItem( IDOK ) )	//	This condition guarantees that all edit controls have been processed.
				{
					ProcessPopupMenu();
				}
				else GotoDlgCtrl( IDOK );
			}
			else ::MessageBeep( -1 );		//	We ignore the close dialog box shortkey during a mouse capture.

			bRtnValue = TRUE;
			break;
		}

/////////////////////////////////////////////////////////////////////////////////////////////////////

	case IDCANCEL:
		{
			if	( m_bIsMouseCaptured )
			{
				EndMouseCapture();
				SetTargetIcon();
				ClearInfoControls();
			}

			bRtnValue = TRUE;
			break;
		}

/////////////////////////////////////////////////////////////////////////////////////////////////////

	case IDC_Cmd__Exit:
		{
			if	( m_bIsMouseCaptured )
			{
				EndMouseCapture();
				SetTargetIcon();
				ClearInfoControls();
			}

			EndDialog( IDOK );

			bRtnValue = TRUE;
			break;
		}

/////////////////////////////////////////////////////////////////////////////////////////////////////

	}

/////////////////////////////////////////////////////////////////////////////////////////////////////

	return( bRtnValue );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-06-18  Modified: 2016-07-12	//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

INT_PTR SWOT_DlgSetWndOnTop::Process_WM_DESTROY()
{
	HICON		hiconTmp;

//---------------------------------------------------------------------------------------------------

	if ( (hiconTmp = (HICON)SendDlgItemMessage( IDC_TargetIcon_IC, STM_GETIMAGE, IMAGE_ICON, 0 )) != 0 )
		::DestroyIcon( hiconTmp );

	//------------------------------------------------

	if ( (hiconTmp = (HICON)SendDlgItemMessage( IDC_CopyInfoToClipboard_BT, BM_GETIMAGE, IMAGE_ICON, 0 )) != 0 )
		::DestroyIcon( hiconTmp );

	if ( (hiconTmp = (HICON)SendDlgItemMessage( IDOK, BM_GETIMAGE, IMAGE_ICON, 0 )) != 0 )
		::DestroyIcon( hiconTmp );

//---------------------------------------------------------------------------------------------------

	return( TRUE );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-06-18  Modified: 2016-07-11	//
//																																	//
//	Purpose:																														//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

INT_PTR SWOT_DlgSetWndOnTop::Process_WM_HELP()
{		
	LPHELPINFO	lphi = (LPHELPINFO)m_pCurMsg->lParam;

	SWOT_GetGlobalApp()->BrowseWebpageLink( m_strHtmlHelpFileName, m_hWnd );

	return( TRUE );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-06-18  Modified: 2017-11-20	//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

INT_PTR SWOT_DlgSetWndOnTop::Process_WM_INITDIALOG()
{
	SWOT_App   *pThisApp = SWOT_GetGlobalApp();
	bool			bStatus  = TRUE;

//---------------------------------------------------------------------------------------------------

	if ( bStatus )
	{
		m_hwndCurSelWnd			  = 0;
		m_hwndCurSelWnd_TopParent = 0;
		m_hwndLastRectDrawn		  = 0;
		m_bIsDlgTopMost			  = TRUE;
		m_bIsAutoFindRootParent	  = TRUE;
		m_bIsDrawInvertedFrame	  = TRUE;
		m_bIsSelWndTopMost		  = FALSE;
		m_bIsMouseCaptured		  = FALSE;

		m_hwndIC_TargetIcon = GetDlgItem( IDC_TargetIcon_IC );

		m_hwndED_Title				 = GetDlgItem( IDC_Title_ED );
		m_hwndED_Class				 = GetDlgItem( IDC_Class_ED );
		m_hwndED_Descriptor		 = GetDlgItem( IDC_Descriptor_ED );
		m_hwndED_Identifier		 = GetDlgItem( IDC_Identifier_ED );
		m_hwndED_Style				 = GetDlgItem( IDC_Style_ED );
		m_hwndED_ExtStyle			 = GetDlgItem( IDC_ExtStyle_ED );
		m_hwndED_Parent			 = GetDlgItem( IDC_Parent_ED );
		m_hwndED_Rectangle		 = GetDlgItem( IDC_Rectangle_ED );
		m_hwndCK_KeepSelWndOnTop = GetDlgItem( IDC_KeepSelWndOnTop_CK );

		m_hwndBT_CopyInfoToClipboard = GetDlgItem( IDC_CopyInfoToClipboard_BT );
		m_hwndBT_Menu					  = GetDlgItem( IDOK );
	}

//---------------------------------------------------------------------------------------------------

	if ( bStatus )
	{
		::GetWindowRect( m_hwndIC_TargetIcon, &rectTargetIcon );
		ScreenToClient( &rectTargetIcon );

		if ( m_hcursorTarget == 0 ) bStatus = FALSE;
	}

//---------------------------------------------------------------------------------------------------

	if ( bStatus )
	{
		CRect		rectDlgDflt, rectDlg;
		CString	strMainWindow;

		SWOT_LoadMiscSettingsFromRegistry( &m_bIsDlgTopMost, &m_bIsAutoFindRootParent, &m_bIsDrawInvertedFrame );

		::GetWindowRect( m_hWnd, &rectDlgDflt );
		strMainWindow.Format( _T("%s\\%s"), (LPCTSTR)pThisApp->m_strRegKey__AppKeyName, SWOT_REG_KEY__MainWindow );
		SWOT_LoadScreenInfoFromRegistry( strMainWindow, rectDlgDflt, &rectDlg );

		::SetWindowPos( m_hWnd, (m_bIsDlgTopMost ? HWND_TOPMOST : HWND_NOTOPMOST),
							 rectDlg.left, rectDlg.top, 0, 0, (SWP_NOSIZE | SWP_NOACTIVATE) );
	}

//---------------------------------------------------------------------------------------------------

//	if ( bStatus )
//	{
//		if ( (m_pDataBkp = new SWOT_DlgSetWndOnTop) != 0 )
//		{
//			SaveDataBkp();
//		}
//		else bStatus = FALSE;
//	}

//---------------------------------------------------------------------------------------------------

	if ( bStatus )
	{
		SetTargetIcon();
		ClearInfoControls();

		::CheckDlgButton( m_hWnd, IDC_KeepDlgOnTop_CK, (m_bIsDlgTopMost ? BST_CHECKED : BST_UNCHECKED) );

		::CheckDlgButton( m_hWnd, IDC_AutoFindRootParent_CK, (m_bIsAutoFindRootParent ? BST_CHECKED : BST_UNCHECKED) );

 		::CheckDlgButton( m_hWnd, IDC_DrawInvertedFrame_CK, ((m_bIsDrawInvertedFrame && !m_bIsAutoFindRootParent) ? BST_CHECKED : BST_UNCHECKED) );

		WiselyEnableWindow( GetDlgItem( IDC_DrawInvertedFrame_CK ), !m_bIsAutoFindRootParent );

		//------------------------------------------------

		::SendMessage( m_hwndBT_CopyInfoToClipboard, BM_SETIMAGE, IMAGE_ICON, (LPARAM)::LoadImage( pThisApp->m_hInstance,
							MAKEINTRESOURCE( SWOT_App::iidirCopy ), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR ) );

		::SendMessage( m_hwndBT_Menu, BM_SETIMAGE, IMAGE_ICON, (LPARAM)::LoadImage( pThisApp->m_hInstance,
							MAKEINTRESOURCE( SWOT_App::iidirPopupMenu ), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR ) );
	}

//---------------------------------------------------------------------------------------------------

	if ( bStatus )
	{
		::SendMessage( m_hWnd, WM_SETICON, ICON_SMALL, (LPARAM)::LoadImage( pThisApp->m_hInstance,
							MAKEINTRESOURCE( IDI_SETWNDONTOP ), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR ) );
//		CenterWindow();
		GotoDlgCtrl( IDOK );
	}
	else EndDialog( -1 );

	return( FALSE );	// FALSE -> System will not call SetFocus()
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-06-18  Modified: 2016-06-18	//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

INT_PTR SWOT_DlgSetWndOnTop::Process_WM_LBUTTONDBLCLK()
{										
	return( Process_WM_LBUTTONDOWN() );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-06-18  Modified: 2016-08-20	//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

INT_PTR SWOT_DlgSetWndOnTop::Process_WM_LBUTTONDOWN()
{
	CPoint	pointParentMouse( GET_X_LPARAM( m_pCurMsg->lParam ), GET_Y_LPARAM( m_pCurMsg->lParam ) );

//---------------------------------------------------------------------------------------------------

	if ( IsMouseOver_TargetIconCtrl( pointParentMouse.x, pointParentMouse.y ) )
	{
		StartMouseCapture();
		::SetCursor( m_hcursorTarget );
		SetTargetIcon( FALSE );
		ClearInfoControls();

		//	We need to disable the "Close" button because the pressing of the 'VK_SPACE' key triggers a 'WM_CAPTURECHANGED' message
		// before we can discard the 'WM_CHAR' message from a customized control procedure that processes 'WM_GETDLGCODE' messages.
		GotoDlgCtrl( IDOK );											
		WiselyEnableWindow( GetDlgItem( IDOK ), FALSE );

		WiselyEnableWindow( GetDlgItem( IDC_KeepDlgOnTop_CK ), FALSE );
 		WiselyEnableWindow( GetDlgItem( IDC_AutoFindRootParent_CK ), FALSE );
		WiselyEnableWindow( GetDlgItem( IDC_DrawInvertedFrame_CK ), FALSE );

		::SetFocus( m_hWnd );	//	Set the focus on the first non-disabled control to enable the processing of the 'VK_ESCAPE' key if pressed.
	}

//---------------------------------------------------------------------------------------------------

	return( TRUE );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-06-18  Modified: 2016-08-19	//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

INT_PTR SWOT_DlgSetWndOnTop::Process_WM_LBUTTONUP()
{
	CPoint	pointScreenMouse( GET_X_LPARAM( m_pCurMsg->lParam ), GET_Y_LPARAM( m_pCurMsg->lParam ) );
	HWND		hwndUnderMouse;

	::ClientToScreen( m_hWnd, &pointScreenMouse );

//---------------------------------------------------------------------------------------------------

	if	( m_bIsMouseCaptured )
	{
		EndMouseCapture();
		SetTargetIcon();
		hwndUnderMouse = GetWndFromPoint( pointScreenMouse );

		if ( (hwndUnderMouse != 0) && ::IsWindow( hwndUnderMouse ) ) SetInfoControls( hwndUnderMouse );
		else																			 ClearInfoControls();
	}

//---------------------------------------------------------------------------------------------------

	return( TRUE );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-06-18  Modified: 2016-08-19	//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

INT_PTR SWOT_DlgSetWndOnTop::Process_WM_MOUSEMOVE()
{
	CPoint	pointScreenMouse( GET_X_LPARAM( m_pCurMsg->lParam ), GET_Y_LPARAM( m_pCurMsg->lParam ) );
	HWND		hwndUnderMouse;

	::ClientToScreen( m_hWnd, &pointScreenMouse );

//---------------------------------------------------------------------------------------------------

	if	( m_bIsMouseCaptured )
	{
		hwndUnderMouse = GetWndFromPoint( pointScreenMouse );

		if ( (hwndUnderMouse != 0) && ::IsWindow( hwndUnderMouse ) )
		{
			if ( m_bIsDrawInvertedFrame && !m_bIsAutoFindRootParent )
			{
				if ( (m_hwndLastRectDrawn != 0) && (m_hwndLastRectDrawn != hwndUnderMouse) ) ClearLastDrawnFrame();

				if ( (m_hwndLastRectDrawn == 0) ) SetLastDrawnFrame( hwndUnderMouse );
			}

			SetInfoControls( hwndUnderMouse );
		}

		//------------------------------------------------

		else
		{
			if ( m_bIsDrawInvertedFrame && !m_bIsAutoFindRootParent && (m_hwndLastRectDrawn != 0) ) ClearLastDrawnFrame();

			ClearInfoControls();
		}
	}

//---------------------------------------------------------------------------------------------------

	return( TRUE );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-06-18  Modified: 2016-06-18	//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

INT_PTR SWOT_DlgSetWndOnTop::Process_WM_NCDESTROY()
{
//	if ( m_pDataBkp != 0 )
//	{
//		delete m_pDataBkp;
//		m_pDataBkp = 0;
//	}

	return( TRUE );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-06-18  Modified: 2016-07-11	//
//																																	//
//	Purpose:																														//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

INT_PTR SWOT_DlgSetWndOnTop::Process_WM_SYSCOMMAND()
{
	bool	bRtnValue = FALSE;	// Set to "message not processed" by default.
	int	nCommandId = (m_pCurMsg->wParam & 0xFFF0);

//---------------------------------------------------------------------------------------------------

	if ( nCommandId == SC_CONTEXTHELP )
	{
		SWOT_GetGlobalApp()->BrowseWebpageLink( m_strHtmlHelpFileName, m_hWnd );
		bRtnValue = TRUE;
	}
	else if ( nCommandId == SC_CLOSE )
	{
		SendMessage( WM_COMMAND, MAKEWPARAM( IDC_Cmd__Exit, 0 ) );
		bRtnValue = TRUE;
	}

//---------------------------------------------------------------------------------------------------

	return( bRtnValue );
}

