/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-07  Modified: 2016-08-20	//
//																																	//
// SWOT_DlgSetWndOnTop.h : Header of the "Set Window On Top & Get Info" dialog box.						//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

//#include "SWOT_DlgSetWndOnTop.h"
#pragma once

#include <afx.h>
#include "SetWndOnTop.h"
#include "resource.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////

class SWOT_DlgSetWndOnTop		//	"Set Window On Top"
{
public:
	enum ControlId
	{
		IDC_TargetIcon_IC			  = 101,
		IDC_KeepDlgOnTop_CK		  = 102,
		IDC_AutoFindRootParent_CK = 103,
		IDC_DrawInvertedFrame_CK  = 104,

		IDC_Title_ED			  = 201,
		IDC_Class_ED			  = 202,
		IDC_Descriptor_ED		  = 203,
		IDC_Identifier_ED		  = 204,
		IDC_Style_ED			  = 205,
		IDC_ExtStyle_ED		  = 206,
		IDC_Parent_ED			  = 207,
		IDC_Rectangle_ED		  = 208,
		IDC_KeepSelWndOnTop_CK = 209,

		IDC_Title_TX		= 301,
		IDC_Class_TX		= 302,
		IDC_Descriptor_TX = 303,
		IDC_Identifier_TX = 304,
		IDC_Style_TX		= 305,
		IDC_ExtStyle_TX	= 306,
		IDC_Parent_TX		= 307,
		IDC_Rectangle_TX	= 308,

		IDC_CopyInfoToClipboard_BT = 401,

		//	Virtual control ID...
		IDC_Cmd__Exit = (WM_USER + 0x7BFF - 0)		//	Used to indicate to exit the application.
	};

	//------------------------------------------------

	enum PopupMenuId
	{
		IDM_Error	  = -1,		//	Error while creating the Popup Menu.
		IDM_NoMenu	  = 0,		//	No Popup Menu available at the specified position or cancelled by the user.
		IDM_CloseMenu = 1,		//	User has selected the "Close this Menu" item.

		IDM_SaveCurSettings = 2,
		IDM_CreateDesktopShortcut,
		IDM_About,
		IDM_Exit,
	};

	//------------------------------------------------

	class GWFPP	//	Used by the 'GetWndFromPoint()' functions.
	{
	public:
		POINT m_pointParentMouse;			//	[IN]
		HWND	m_hwndParent;					//	[IN]
		RECT	m_rectClient;					//	[IN]
		bool	m_bScanAllChildWnd;			//	[IN]
		bool	m_bExcludeDisabledWindow;	//	[IN]
		HWND	m_hwndChildUnderMouse;		//	[OUT]

		GWFPP() { Initialize(); }
		void Initialize()
		{
			m_pointParentMouse.x = m_pointParentMouse.y = 0;
			m_hwndParent = 0;
			m_rectClient.left = m_rectClient.top = 0;
			m_rectClient.right = m_rectClient.bottom = 1;
			m_bScanAllChildWnd = FALSE;
			m_bExcludeDisabledWindow = FALSE;
			m_hwndChildUnderMouse = 0;
		}
	};

//---------------------------------------------------------------------------------------------------

	HWND				m_hwndParent;		// Must be specified by user.
	HINSTANCE		m_hInstance;		// Specified by the user or auto set to default in the constructor if == 0.
	CString			m_strTemplate;
	CString			m_strHtmlHelpFileName;

	HWND				m_hWnd;				// Set when the window is created.  Cleared when it is destroyed.
	INT_PTR			m_npResult;			// Useful to pass a return value.
	MSG			  *m_pCurMsg;			// Pointer to a copy of currently processed message.  Never attempt to free
												//	 the pointed memory because it is managed internally in DispatchMsgProcedure(). 

	//------------------------------------------------

	HWND				m_hwndCurSelWnd;					//	Currently selected window.
	HWND				m_hwndCurSelWnd_TopParent;		//	Top parent of currently selected window.
	HWND				m_hwndLastRectDrawn;
	HCURSOR			m_hcursorTarget;
	bool				m_bIsDlgTopMost;
	bool				m_bIsAutoFindRootParent;
	bool				m_bIsDrawInvertedFrame;
	bool				m_bIsSelWndTopMost;
	bool				m_bIsMouseCaptured;		//	Used to indicate that 'SetCapture()' or 'ReleaseCapture()' has been called.

//---------------------------------------------------------------------------------------------------
protected:	// For internal access only.

	HWND				m_hwndIC_TargetIcon;

	HWND				m_hwndED_Title;
	HWND				m_hwndED_Class;
	HWND				m_hwndED_Descriptor;
	HWND				m_hwndED_Identifier;
	HWND				m_hwndED_Style;
	HWND				m_hwndED_ExtStyle;
	HWND				m_hwndED_Parent;
	HWND				m_hwndED_Rectangle;
	HWND				m_hwndCK_KeepSelWndOnTop;

	HWND				m_hwndBT_CopyInfoToClipboard;
	HWND				m_hwndBT_Menu;

	CRect				rectTargetIcon;

	//------------------------------------------------

//	bool					m_bIsTrackingMouseLeaveEnabled;	//	Used to indicate that TrackMouseEvent( TME_LEAVE ) has been called.
	bool					m_bModalMode;							// Internal use only.
//	SWOT_DlgSetWndOnTop  *m_pDataBkp;								//	Used to restore the data members when the user selects the "Cancel" button.

//---------------------------------------------------------------------------------------------------
public:

	SWOT_DlgSetWndOnTop( HWND hwndParent = 0, HINSTANCE hInstance = 0, LPCTSTR pcszTemplate = MAKEINTRESOURCE( IDD_SET_WND_ON_TOP ) );
	~SWOT_DlgSetWndOnTop();

	static INT_PTR ShowSetWndOnTop( HWND hwndParent = 0 );

//---------------------------------------------------------------------------------------------------
protected:	// For internal access only.

//	static bool BackupDataMembers( SWOT_DlgSetWndOnTop *pDst, const SWOT_DlgSetWndOnTop *pcSrc );
//	bool SaveDataBkp() const { return( BackupDataMembers( m_pDataBkp, this ) ); }
//	bool RestoreDataBkp()	 { return( BackupDataMembers( this, m_pDataBkp ) ); }

	void SetTargetIcon( const bool cbWindowWithTarget = TRUE );
	void SetInfoControls( HWND hWnd = 0 );
	void ClearInfoControls() { SetInfoControls(); }
	void StartMouseCapture();
	void EndMouseCapture();
	bool SetLastDrawnFrame( HWND hwndUnderMouse );
	bool ClearLastDrawnFrame();
	bool IsMouseOver_TargetIconCtrl( const int cnPosX, const int cnPosY ) const;
	int  ProcessPopupMenu();
	bool CopyInfoToClipboard();

	//------------------------------------------------

	static BOOL CALLBACK GetWndFromPointProc( HWND hwnd, LPARAM lParam );
	HWND GetWndFromPoint( POINT pointScreenMouse, const bool cbExcludeDisabledWindow = FALSE, const bool cbCheckDescendantWindow = TRUE );
	void InvertFrame( HDC hdcWnd, LPRECT lpRect );
	HWND GetChildWndRectRelToParent( HWND hwndChild, LPRECT lpRect );

//---------------------------------------------------------------------------------------------------
public:

	static bool WiselyEnableWindow( HWND hWnd, bool bEnable )
	{
		bool	bPreviouslyDisabled = (::IsWindowEnabled( hWnd ) == 0);

		if ( (bPreviouslyDisabled && bEnable) || (!bPreviouslyDisabled && !bEnable) ) ::EnableWindow( hWnd, bEnable );

		return( bPreviouslyDisabled );
	}

//---------------------------------------------------------------------------------------------------

	bool		Attach( HWND hwndNew ) { if ( (m_hWnd != 0) || (hwndNew == 0) || !::IsWindow( hwndNew ) ) return( FALSE );  m_hWnd = hwndNew;  return( TRUE ); }
	//void		CenterWindow( HWND hwndAlternateOwner = 0 ) { SWOT_CenterWindow( m_hWnd, ((hwndAlternateOwner == 0) ? ::GetParent( m_hWnd ) : hwndAlternateOwner) ); }
	//bool		ClientToScreen( LPPOINT lpPoint ) const { return( (::ClientToScreen( m_hWnd, lpPoint ) != 0) ); }
	//bool		ClientToScreen( LPRECT lpRect ) const { return( (::ClientToScreen( m_hWnd, (LPPOINT)lpRect ) && ::ClientToScreen( m_hWnd, ((LPPOINT)lpRect) + 1 )) ); }
	HWND		Detach() { HWND hWnd = m_hWnd;	m_hWnd = 0;		return( hWnd ); }
	INT_PTR	DoModal();
	bool		EndDialog( INT_PTR npResult ) { return( (::EndDialog( m_hWnd, npResult ) != 0) ); }
	HWND		GetDlgItem( int nIDDlgItem ) const { return( ::GetDlgItem( m_hWnd, nIDDlgItem ) ); }
	HWND		GetParent() const { return( ::GetParent( m_hWnd ) ); }
	bool		ScreenToClient( LPPOINT lpPoint ) const { return( (::ScreenToClient( m_hWnd, lpPoint ) != 0) ); }
	bool		ScreenToClient( LPRECT lpRect ) const { return( (::ScreenToClient( m_hWnd, (LPPOINT)lpRect ) && ::ScreenToClient( m_hWnd, ((LPPOINT)lpRect) + 1 )) ); }
	LRESULT	SendDlgItemMessage( int nIDDlgItem, UINT Msg, WPARAM wParam = 0, LPARAM lParam = 0 ) { return( ::SendDlgItemMessage( m_hWnd, nIDDlgItem, Msg, wParam, lParam ) ); }
	LRESULT	SendMessage( UINT Msg, WPARAM wParam = 0, LPARAM lParam = 0 ) { return( ::SendMessage( m_hWnd, Msg, wParam, lParam ) ); }

//---------------------------------------------------------------------------------------------------

	void	GotoDlgCtrl( HWND hCtrl ) { ::SendMessage( m_hWnd, WM_NEXTDLGCTL, (WPARAM)hCtrl, MAKELPARAM( TRUE, 0 ) ); }
	void	GotoDlgCtrl( int nIDDlgItem ) { GotoDlgCtrl( ::GetDlgItem( m_hWnd, nIDDlgItem ) ); }

//---------------------------------------------------------------------------------------------------
protected:	// For internal access only.

	static INT_PTR CALLBACK DlgAboutProc( HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam );

	static INT_PTR CALLBACK DispatchMsgProcedure( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam );

	//------------------------------------------------

	virtual INT_PTR Modal_ProcessCurrentMessage();

	INT_PTR Process_WM_CAPTURECHANGED();
	INT_PTR Process_WM_COMMAND();
	INT_PTR Process_WM_DESTROY();
	INT_PTR Process_WM_HELP();
	INT_PTR Process_WM_INITDIALOG();
	INT_PTR Process_WM_LBUTTONDBLCLK();
	INT_PTR Process_WM_LBUTTONDOWN();
	INT_PTR Process_WM_LBUTTONUP();
	INT_PTR Process_WM_MOUSEMOVE();
	INT_PTR Process_WM_NCDESTROY();
	INT_PTR Process_WM_SYSCOMMAND();
};

/////////////////////////////////////////////////////////////////////////////////////////////////////
