/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-07  Modified: 2016-09-08	//
//																																	//
// SetWndOnTop.cpp : Defines the entry point for the "Set Window On Top" application.					//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SetWndOnTop.h"
#include "SWOT_App.h"
#include "SWOT_Global.h"
#include "SWOT_Pixel.h"
#include "SWOT_PixelMap.h"
#include <mmsystem.h>
#include <shlwapi.h>

/////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////

SWOT_App	ThisApp;

/////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-07  Modified: 2016-07-11	//
//																																	//
//	Purpose:	Defines the entry point for the application.															//
//																																	//
//	Result:																														//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

int APIENTRY _tWinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow )
{
	UNREFERENCED_PARAMETER( hPrevInstance );

	bool		bExit = FALSE;

//---------------------------------------------------------------------------------------------------

	bExit = !SWOT_InitInstance( hInstance, lpCmdLine, nCmdShow );	// Perform application initialization.
 
//---------------------------------------------------------------------------------------------------

	if ( !bExit )
	{
//		FOREVER
//		{
//			if ( !ThisApp.ProcessMessages( TRUE, ThisApp.m_hAccelTable ) ) break;	//	We exit loop if the 'WM_QUIT' message has been received.
//
//			if ( !WaitMessage() ) break;
//		}
	}

//---------------------------------------------------------------------------------------------------

	SWOT_ExitInstance();	// Perform application cleanup.

	return( ThisApp.m_nExitValue );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-07  Modified: 2016-07-11	//
//																																	//
//	Purpose:																														//
//																																	//
//	Result: Returns TRUE if successful.  Otherwise returns FALSE.												//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

bool SWOT_InitInstance( HINSTANCE hInstanceApp, LPTSTR pszCmdLine, int nCmdShow )
{
	bool	bExit = FALSE;
	
//---------------------------------------------------------------------------------------------------

	if ( !bExit && !ThisApp.Initialize( hInstanceApp, pszCmdLine, nCmdShow ) )
	{
		bExit = TRUE;
	}
	
//---------------------------------------------------------------------------------------------------

	if ( !bExit && !ThisApp.OpenMainWindow() ) bExit = TRUE;

//---------------------------------------------------------------------------------------------------

	return( !bExit );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-07  Modified: 2016-07-11	//
//																																	//
//	Purpose:																														//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

void SWOT_ExitInstance()
{
	ThisApp.CloseMainWindow();
	ThisApp.Cleanup();
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2000-07-18  Modified: 2015-07-22	//
//																																	//
//	Purpose:																														//
//																																	//
//	Result:																														//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

long SWOT_RegWriteInteger( HKEY hRootKey, const char *pcszKey, const char *pcszValueName, const int cnValue )
{
   HKEY		hkCurrent = 0;
	HRESULT	lResult1, lResult2;
   DWORD		dwDisposition;

//---------------------------------------------------------------------------------------------------

   if ( (lResult1 = RegCreateKeyEx( hRootKey, pcszKey, 0, "", REG_OPTION_NON_VOLATILE,
				KEY_ALL_ACCESS, 0, &hkCurrent, &dwDisposition )) == ERROR_SUCCESS )
	{
		lResult1 = RegSetValueEx( hkCurrent, pcszValueName, 0, REG_DWORD,
											(const unsigned char *)&cnValue, sizeof( cnValue ) );
		lResult2 = RegCloseKey( hkCurrent );

		if ( (lResult1 == ERROR_SUCCESS) && (lResult2 != ERROR_SUCCESS) ) lResult1 = lResult2;
	}

//---------------------------------------------------------------------------------------------------

	return( lResult1 );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2000-07-18  Modified: 2016-03-19	//
//																																	//
//	Purpose:																														//
//																																	//
//	Result: If the return value is not 'ERROR_SUCCESS' then *('pnValue') will be set with				//
//			  'cnDefaultValue'.																								//
//																																	//
// Note:	When 'pcszValueName' specifies the default value name and the default value cannot 			//
//			fit in 'pnValue', then 'ERROR_MORE_DATA' is returned.													//
//																																	//
// Note:	When 'pcszValueName' specifies the default value name, 'ERROR_OUTOFMEMORY' or					//
//			'ERROR_BADKEY' can also be returned.																		//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

long SWOT_RegReadInteger( HKEY hRootKey, const char *pcszKey, const char *pcszValueName, const int cnDefaultValue, int *pnValue )
{
	HKEY		hkCurrent = 0;
	DWORD		dwType	 = REG_NONE;
	int		nDefaultValueCount;
	DWORD		dwSize;
	HRESULT	lResult1, lResult2;

//---------------------------------------------------------------------------------------------------
//	This is a patch because when the default value does not exist, RegQueryValueEx() always returns
//	an empty string with the ERROR_SUCCESS error code.

	if ( (pcszValueName == 0) || (_tcslen( pcszValueName ) == 0) )	// Ask for the default value?
	{
		lResult1 = SWOT_RegTestKey( hRootKey, pcszKey, 0, &nDefaultValueCount, 0 );

		if ( (lResult1 == ERROR_SUCCESS) && (nDefaultValueCount == 0) ) lResult1 = ERROR_FILE_NOT_FOUND;
	}
	else lResult1 = ERROR_SUCCESS;

//---------------------------------------------------------------------------------------------------

	if ( lResult1 == ERROR_SUCCESS )
	{
		if ( (lResult1 = RegOpenKeyEx( hRootKey, pcszKey, 0, KEY_READ, &hkCurrent )) == ERROR_SUCCESS )
		{
			dwSize	= sizeof( *pnValue );
			lResult1 = RegQueryValueEx( hkCurrent, pcszValueName, 0, &dwType, (LPBYTE)pnValue, &dwSize );
			lResult2 = RegCloseKey( hkCurrent );

			if ( (lResult1 == ERROR_SUCCESS) && (dwType != REG_DWORD) ) lResult1 = ERROR_INVALID_DATATYPE;

			if ( (lResult1 == ERROR_SUCCESS) && (lResult2 != ERROR_SUCCESS) ) lResult1 = lResult2;
		}
	}

//---------------------------------------------------------------------------------------------------

	if ( lResult1 != ERROR_SUCCESS )	*(pnValue) = cnDefaultValue;

	return( lResult1 );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2001-11-23  Modified: 2015-07-22	//
//																																	//
//	Purpose:																														//
//																																	//
//	Result: ERROR_OUTOFMEMORY, ERROR_BADKEY, ERROR_FILE_NOT_FOUND or ERROR_SUCCESS.						//
//																																	//
// Note:	If result is not ERROR_SUCCESS then contents of 'pnSubKeyCount', 'pnDefaultValueCount'		//
//			and 'pnNonDefaultValueCount' are set to 0.  Boolean pointers maybe set to 0 if their		//
//			respective result is not needed.																				//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

#define	TT_MAX_KEY_LENGTH		(255 + EOS_CHAR_COUNT)

DWORD SWOT_RegTestKey( HKEY hRootKey, const char *pcszKey, int *pnSubKeyCount, int *pnDefaultValueCount, int *pnNonDefaultValueCount )
{
   HKEY		hkCurrent = 0;
	char	  *pszKeyOrValueName;
	int		nSubKeyCount, nDefaultValueCount, nNonDefaultValueCount;
	HRESULT	lResult1, lResult2;
	DWORD		dwKeyOrValueNameLength;

	nSubKeyCount = nDefaultValueCount = nNonDefaultValueCount = 0;

//---------------------------------------------------------------------------------------------------

	if ( (pszKeyOrValueName = new char [TT_MAX_KEY_LENGTH]) != 0 )
	{
		if ( (pcszKey != 0) && (_tcslen( pcszKey ) != 0) )	//	Do not allow 0 or empty key name
		{
			if ( (lResult1 = RegOpenKeyEx( hRootKey, pcszKey, 0, KEY_READ, &hkCurrent )) == ERROR_SUCCESS )
			{

//---------------------------------------------------------------------------------------------------

				for( ; lResult1 == ERROR_SUCCESS; nSubKeyCount++ )
				{
					dwKeyOrValueNameLength = TT_MAX_KEY_LENGTH;
					lResult1 = RegEnumKeyEx( hkCurrent, nSubKeyCount, pszKeyOrValueName, &dwKeyOrValueNameLength, 0, 0, 0, 0 );

					if ( lResult1 == ERROR_NO_MORE_ITEMS )
					{
						lResult1 = ERROR_SUCCESS;
						break;
					}
				}

//---------------------------------------------------------------------------------------------------

				for( ; lResult1 == ERROR_SUCCESS; nNonDefaultValueCount++ )
				{
					dwKeyOrValueNameLength = TT_MAX_KEY_LENGTH;
					lResult1 = RegEnumValue( hkCurrent, nNonDefaultValueCount, pszKeyOrValueName, &dwKeyOrValueNameLength, 0, 0, 0, 0 );
 
					if ( lResult1 == ERROR_NO_MORE_ITEMS )
					{
						nNonDefaultValueCount -= nDefaultValueCount;
						lResult1 = ERROR_SUCCESS;
						break;
					}
					else if ( lResult1 == ERROR_SUCCESS )
					{
						if ( _tcslen( pszKeyOrValueName ) == 0 ) nDefaultValueCount++;	// Only one per Key.
					}
				}

//---------------------------------------------------------------------------------------------------

				lResult2 = RegCloseKey( hkCurrent );

				if ( (lResult1 == ERROR_SUCCESS) && (lResult2 != ERROR_SUCCESS) ) lResult1 = lResult2;
			}
		}
		else
		{
			lResult1 = ERROR_BADKEY;
		}

		delete [] pszKeyOrValueName;
		pszKeyOrValueName = 0;
	}
	else
	{
		lResult1 = ERROR_OUTOFMEMORY;
	}
	
//---------------------------------------------------------------------------------------------------

	if ( lResult1 != ERROR_SUCCESS ) nSubKeyCount = nDefaultValueCount = nNonDefaultValueCount = 0;

	if ( pnSubKeyCount			 != 0 ) pnSubKeyCount[0]			 = nSubKeyCount;
	if ( pnDefaultValueCount	 != 0 ) pnDefaultValueCount[0]	 = nDefaultValueCount;
	if ( pnNonDefaultValueCount != 0 ) pnNonDefaultValueCount[0] = nNonDefaultValueCount;

	return( lResult1 );
}

#undef	TT_MAX_KEY_LENGTH


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-11  Modified: 2016-08-12	//
//																																	//
//	Purpose:	Loads the application settings from the Registry.													//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

void SWOT_LoadMiscSettingsFromRegistry( bool *pbIsKeepDlgOnTop, bool *pbIsAutoFindRootParent, bool *pbIsDrawInvertedFrame )
{
	int	nKeepDialogOnTop, nKeepDialogOnTop_DfltVal;
	int	nAutoFindRootParent, nAutoFindRootParent_DfltVal;
	int	nDrawInvertedFrame, nDrawInvertedFrame_DfltVal;

//---------------------------------------------------------------------------------------------------

	nKeepDialogOnTop_DfltVal = TRUE;
	SWOT_RegReadInteger( HKEY_CURRENT_USER, ThisApp.m_strRegKey__AppKeyName, SWOT_REG_VAR__KeepDialogOnTop,
								 nKeepDialogOnTop_DfltVal, &nKeepDialogOnTop );

	if ( pbIsKeepDlgOnTop != NULL ) *(pbIsKeepDlgOnTop) = (nKeepDialogOnTop != 0);

//---------------------------------------------------------------------------------------------------

	nAutoFindRootParent_DfltVal = TRUE;
	SWOT_RegReadInteger( HKEY_CURRENT_USER, ThisApp.m_strRegKey__AppKeyName, SWOT_REG_VAR__AutoFindRootParent,
								 nAutoFindRootParent_DfltVal, &nAutoFindRootParent );

	if ( pbIsAutoFindRootParent != NULL ) *(pbIsAutoFindRootParent) = (nAutoFindRootParent != 0);

//---------------------------------------------------------------------------------------------------

	nDrawInvertedFrame_DfltVal = TRUE;
	SWOT_RegReadInteger( HKEY_CURRENT_USER, ThisApp.m_strRegKey__AppKeyName, SWOT_REG_VAR__DrawInvertedFrame,
								 nDrawInvertedFrame_DfltVal, &nDrawInvertedFrame );

	if ( pbIsDrawInvertedFrame != NULL ) *(pbIsDrawInvertedFrame) = (nDrawInvertedFrame != 0);
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-11  Modified: 2016-08-12	//
//																																	//
//	Purpose:	Saves the application settings to the Registry.														//
//																																	//
//	Result: See the Registry functions for possible returned values.											//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

int SWOT_SaveMiscSettingsToRegistry( const bool cbIsKeepDlgOnTop, const bool cbIsAutoFindRootParent, const bool cbIsDrawInvertedFrame )
{
	HRESULT	lResult01, lResult02, lResult03;

//---------------------------------------------------------------------------------------------------

	lResult01 = SWOT_RegWriteInteger( HKEY_CURRENT_USER, ThisApp.m_strRegKey__AppKeyName,
												 SWOT_REG_VAR__KeepDialogOnTop	, (int)cbIsKeepDlgOnTop );

	lResult02 = SWOT_RegWriteInteger( HKEY_CURRENT_USER, ThisApp.m_strRegKey__AppKeyName,
												 SWOT_REG_VAR__AutoFindRootParent, (int)cbIsAutoFindRootParent );

	lResult03 = SWOT_RegWriteInteger( HKEY_CURRENT_USER, ThisApp.m_strRegKey__AppKeyName,
												 SWOT_REG_VAR__DrawInvertedFrame, (int)cbIsDrawInvertedFrame );

//---------------------------------------------------------------------------------------------------

	if ( lResult01 == ERROR_SUCCESS )
	{
		if ( lResult02 != ERROR_SUCCESS ) lResult01 = lResult02;
		if ( lResult03 != ERROR_SUCCESS ) lResult01 = lResult03;
	}

//---------------------------------------------------------------------------------------------------

	return( lResult01 );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2003-11-17  Modified: 2016-07-11	//
//																																	//
//	Purpose:																														//
//																																	//
// Note:	'pun64FileVersion', 'pszFileVersion', 'pun64ProductVersion' and 'pszProductVersion'			//
//			may be set to 0.  If 'pszFileVersion' or 'pszProductVersion' are not 0 then they must		//
//			contain enough space for SWOT_MINSTRBUF__VERSION characters, NULL character included.		//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

bool SWOT_SHGetVersionNumbers( LPCTSTR pcszFileName, unsigned __int64 *pun64FileVersion, LPTSTR pszFileVersion,
																	  unsigned __int64 *pun64ProductVersion, LPTSTR pszProductVersion )
{
	bool						bStatus				 = FALSE;
	LPVOID					pData					 = 0;
	unsigned __int64		un64FileVersion	 = 0;
	unsigned __int64		un64ProductVersion = 0;
	DWORD						dwUseless, dwFVISize, dwFFISize, dwVer1, dwVer2;
	VS_FIXEDFILEINFO	  *pFFI;
	TCHAR						szFileVersion[SWOT_MINSTRBUF__VERSION]	 = _T("0.0.0.0");
	TCHAR						szProductVersion[SWOT_MINSTRBUF__VERSION] = _T("0.0.0.0");

//---------------------------------------------------------------------------------------------------

	dwFVISize = GetFileVersionInfoSize( (LPTSTR)pcszFileName, &dwUseless );

	if ( dwFVISize != 0 ) 
	{ 
		if ( (pData = malloc( dwFVISize )) != 0 )
		{
			if ( GetFileVersionInfo( (LPTSTR)pcszFileName, 0, dwFVISize, pData ) != 0 )
			{
				if ( VerQueryValue( pData, _T("\\"), (LPVOID *)&pFFI, (PUINT)&dwFFISize ) )
				{
					bStatus = TRUE;

					dwVer1 = pFFI->dwFileVersionMS; 
					dwVer2 = pFFI->dwFileVersionLS; 
					un64FileVersion = (((unsigned __int64)dwVer1 << 32) | dwVer2);
					_stprintf( szFileVersion, _T("%ld.%ld.%ld.%ld"), HIWORD( dwVer1 ), LOWORD( dwVer1 ), HIWORD( dwVer2 ), LOWORD( dwVer2 ) );

					dwVer1 = pFFI->dwProductVersionMS; 
					dwVer2 = pFFI->dwProductVersionLS; 
					un64ProductVersion = (((unsigned __int64)dwVer1 << 32) | dwVer2);
					_stprintf( szProductVersion, _T("%ld.%ld.%ld.%ld"), HIWORD( dwVer1 ), LOWORD( dwVer1 ), HIWORD( dwVer2 ), LOWORD( dwVer2 ) );
				}
			}

			free( pData );
			pData = 0;
		}
	}

//---------------------------------------------------------------------------------------------------

	if ( pun64FileVersion	 != 0 ) *(pun64FileVersion) = un64FileVersion;
	if ( pszFileVersion		 != 0 ) _tcscpy( pszFileVersion, szFileVersion );
	if ( pun64ProductVersion != 0 ) *(pun64ProductVersion) = un64ProductVersion;
	if ( pszProductVersion	 != 0 ) _tcscpy( pszProductVersion, szProductVersion );

	return( bStatus ); 
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2008-09-12  Modified: 2016-07-11	//
//																																	//
//	Purpose:																														//
//																																	//
//	'prectWorkArea': May be 0 if you do not need this information.  Will contain the values			//
//						  about the WorkArea of the target monitor.													//
//																																	//
//	'prectMonitor': May be 0 if you do not need this information.  Will contain the values				//
//						 about the target monitor.																			//
//																																	//
//	'pMonitorInfoEx': May be 0 if you do not need this information.  Will contain all the				//
//						   available information about the target monitor.											//
//																																	//
//	'cdwFlags': See MonitorFromRect() for possible values.  Default is MONITOR_DEFAULTTONEAREST.		//
//																																	//
//	Result: Returns FALSE only if functions MonitorFromRect() or GetMonitorInfo() failed and			//
//			  default values of primary display are returned instead.  Otherwise returns TRUE.			//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

bool SWOT_GetMonitorAndWorkAreaInfoFromRect( const CRect & rcrectWindow, CRect *prectWorkArea, CRect *prectMonitor,
															LPMONITORINFOEX pMonitorInfoEx, const DWORD cdwFlags )
{
	bool					bStatus = TRUE;
	CRect					rectMonitor, rectWorkArea;
	HMONITOR				hMonitor;
	MONITORINFOEX		monitorInfoEx;
  					 
	monitorInfoEx.cbSize = sizeof( MONITORINFOEX );

//---------------------------------------------------------------------------------------------------

	if ( ((hMonitor = MonitorFromRect( rcrectWindow, cdwFlags )) != 0) && (GetMonitorInfo( hMonitor, &monitorInfoEx ) != 0) )
	{
		rectWorkArea = monitorInfoEx.rcWork;
		rectMonitor  = monitorInfoEx.rcMonitor;
	}
	else
	{
		bStatus = FALSE;		//	Indicates we are using default values.

		rectMonitor.left   = rectMonitor.top = 0;
		rectMonitor.right  = ::GetSystemMetrics( SM_CXSCREEN );
		rectMonitor.bottom = ::GetSystemMetrics( SM_CYSCREEN );

		if ( !SystemParametersInfo( SPI_GETWORKAREA, 0, &rectWorkArea, 0 ) ) rectWorkArea = rectMonitor;

		memset( &monitorInfoEx, 0, sizeof( MONITORINFOEX ) );
		monitorInfoEx.cbSize		= sizeof( MONITORINFOEX );
		monitorInfoEx.rcMonitor = rectMonitor;
		monitorInfoEx.rcWork		= rectWorkArea;
		monitorInfoEx.dwFlags	= MONITORINFOF_PRIMARY;
		_tcscpy( monitorInfoEx.szDevice, _T("\\\\.\\DISPLAY1") );
	}

//---------------------------------------------------------------------------------------------------

	if ( prectWorkArea  != 0 ) *(prectWorkArea ) = rectWorkArea;
	if ( prectMonitor   != 0 ) *(prectMonitor  ) = rectMonitor;
	if ( pMonitorInfoEx != 0 ) *(pMonitorInfoEx) = monitorInfoEx;

	return( bStatus );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2000-11-22  Modified: 2016-07-11	//
//																																	//
//	Purpose:	Center 'hwndChild' window on 'hwndParent' window or Work Area if 'hwndParent' is	set	//
//				to 0.  The 'hwndChild' window will be always entirely visible inside the Work Area.		//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

void SWOT_CenterWindow( HWND hwndChild, HWND hwndParent )
{
	CRect		rectChild, rectParent, rectWorkArea, rectMonitorBait, rectDlgMaxBounds;
	int		nLeft, nTop, nExtraBorderX, nExtraBorderY;

//---------------------------------------------------------------------------------------------------

	GetWindowRect( hwndChild, &rectChild );
	ThisApp.GetWindowBoundsRect( hwndChild, &rectDlgMaxBounds );
	nExtraBorderX = ((rectDlgMaxBounds.Width()  - rectChild.Width() ) / 2);
	nExtraBorderY = ((rectDlgMaxBounds.Height() - rectChild.Height()) / 2);

	//------------------------------------------------

	if ( hwndParent != 0 ) GetWindowRect( hwndParent, &rectMonitorBait );
	else						  rectMonitorBait = rectChild;

	SWOT_GetMonitorAndWorkAreaInfoFromRect( rectMonitorBait, &rectWorkArea );

	if ( hwndParent != 0 ) rectParent = rectMonitorBait;
	else						  rectParent = rectWorkArea;

	//------------------------------------------------

	nLeft = rectParent.left + ((rectParent.Width()  - rectChild.Width() ) / 2);
	nTop	= rectParent.top  + ((rectParent.Height() - rectChild.Height()) / 2);

	if ( (nLeft + (rectChild.Width() + nExtraBorderX)) > rectWorkArea.right )
		nLeft = (rectWorkArea.right - (rectChild.Width() + nExtraBorderX));

	if ( (nTop + (rectChild.Height() + nExtraBorderY)) > rectWorkArea.bottom )
		nTop = (rectWorkArea.bottom - (rectChild.Height() + nExtraBorderY));

	if ( (nLeft - nExtraBorderX) < rectWorkArea.left ) nLeft = (rectWorkArea.left + nExtraBorderX);
	if ( (nTop  - nExtraBorderY) < rectWorkArea.top  ) nTop  = (rectWorkArea.top  + nExtraBorderY);

	SetWindowPos( hwndChild, 0, nLeft, nTop, 0, 0, (SWP_NOSIZE | SWP_NOZORDER) );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2000-11-28  Modified: 2016-08-17	//
//																																	//
//	Purpose:																														//
//																																	//
//	Result:																														//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

CString SWOT_GetWindowText( HWND hwnd )
{
	LPTSTR	pszTmp;
	CString	strTmp;
	int		nTmpStrLength;

//---------------------------------------------------------------------------------------------------

//	nTmpStrLength = GetWindowTextLength( hwnd );
	nTmpStrLength = ::SendMessage( hwnd, WM_GETTEXTLENGTH , 0, 0 );

	if ( (pszTmp = strTmp.GetBuffer( nTmpStrLength )) != 0 )
	{
//		nTmpStrLength = GetWindowText( hwnd, pszTmp, (nTmpStrLength + EOS_CHAR_COUNT) );
		nTmpStrLength = ::SendMessage( hwnd, WM_GETTEXT, (nTmpStrLength + EOS_CHAR_COUNT), (LPARAM)pszTmp );
		strTmp.ReleaseBuffer( nTmpStrLength );
	}
	else strTmp.Empty();		// Memory error

//---------------------------------------------------------------------------------------------------

	return( strTmp );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2008-09-10  Modified: 2016-07-12	//
//																																	//
//	Purpose:																														//
//																																	//
//	'pcszScreenRegKeyName': Example: "Software\Adeluc\Three Timers V2\MainWindow".						//
//																																	//
//	'pcrectScreenDefault': Contains default values.																	//
//																																	//
//	'prectScreen': May be 0 if you do not need this information.  Will contain the values about		//
//						the requested screen.  The screen is always aligned on WorkArea sides.  If the	//
//						screen dimensions are bigger than the WorkArea dimensions, then the screen will	//
//						be aligned on top/left edges of WorkArea.														//
//																																	//
//	'prectWorkArea': May be 0 if you do not need this information.  Will contain the values about	//
//						  the WorkArea of the target monitor.															//
//																																	//
//	'prectMonitor': May be 0 if you do not need this information.  Will contain the values about		//
//						 the target monitor.																					//
//																																	//
//	Result: Returns TRUE if the returned values come from the Registry.  Otherwise returns FALSE 	//
//			  if the returned values are default values or corrected values.									//
//																																	//
//	Note: The saved application screen position may become invalid if the monitor has been moved		//
//			or if the monitor no more exists.  When this happens the saved position is ignored and		//
//			the screen is centered in its new owner monitor work area with its default size.				//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

bool SWOT_LoadScreenInfoFromRegistry( LPCTSTR pcszScreenRegKeyName, const CRect & rcrectScreenDefault,
			 									  CRect *prectScreen, CRect *prectWorkArea, CRect *prectMonitor,
												  const bool cbCenterInWorkArea, const bool cbAlignToWorkAreaEdges )
{
	bool		bFound = FALSE;	//	Set to not found by default.
	bool		bUnalteredValuesFromReg;
	CString	strMonitorRect, strTmp;
	CRect		rectScreen1, rectScreen2, rectMonitor, rectWorkArea, rectTmp;
	int		nValue;

//---------------------------------------------------------------------------------------------------
	
	if ( SWOT_RegReadInteger( HKEY_CURRENT_USER, pcszScreenRegKeyName, SWOT_REG_VAR__X, 0, &nValue ) == ERROR_SUCCESS )
	{
		rectScreen1.left = rectScreen1.right = nValue;

		if ( SWOT_RegReadInteger( HKEY_CURRENT_USER, pcszScreenRegKeyName, SWOT_REG_VAR__Y, 0, &nValue ) == ERROR_SUCCESS )
		{
			rectScreen1.top = rectScreen1.bottom = nValue;

			if ( SWOT_RegReadInteger( HKEY_CURRENT_USER, pcszScreenRegKeyName, SWOT_REG_VAR__CX, 0, &nValue ) == ERROR_SUCCESS )
			{
				rectScreen1.right += nValue;

				if ( SWOT_RegReadInteger( HKEY_CURRENT_USER, pcszScreenRegKeyName, SWOT_REG_VAR__CY, 0, &nValue ) == ERROR_SUCCESS )
				{
					rectScreen1.bottom += nValue;
					rectTmp = rectScreen1;
					rectTmp.NormalizeRect();
					bFound = ((rectScreen1 == rectTmp) != 0);
				}
			}
		}
	}

	//------------------------------------------------

	if ( !bFound )	//	Memory error or at least one key or variable not found?
	{
		rectScreen1.left	 = rcrectScreenDefault.left;
		rectScreen1.top	 = rcrectScreenDefault.top;
		rectScreen1.right  = rcrectScreenDefault.Width();
		rectScreen1.bottom = rcrectScreenDefault.Height();
	}
	
	SWOT_GetMonitorAndWorkAreaInfoFromRect( rectScreen1, &rectWorkArea, &rectMonitor );

//---------------------------------------------------------------------------------------------------

	if ( bFound )
	{
		strTmp.Format( SWOT_REG_KEY__MonitorRectangle, rectMonitor.left, rectMonitor.top, rectMonitor.right, rectMonitor.bottom );
		strMonitorRect.Format( _T("%s\\%s"), pcszScreenRegKeyName, (LPCTSTR)strTmp );
		bFound = FALSE;	//	Set to not found by default.

		if ( SWOT_RegReadInteger( HKEY_CURRENT_USER, strMonitorRect, SWOT_REG_VAR__X, 0, &nValue ) == ERROR_SUCCESS )
		{
			rectScreen2.left = rectScreen2.right = nValue;

			if ( SWOT_RegReadInteger( HKEY_CURRENT_USER, strMonitorRect, SWOT_REG_VAR__Y, 0, &nValue ) == ERROR_SUCCESS )
			{
				rectScreen2.top = rectScreen2.bottom = nValue;

				if ( SWOT_RegReadInteger( HKEY_CURRENT_USER, strMonitorRect, SWOT_REG_VAR__CX, 0, &nValue ) == ERROR_SUCCESS )
				{
					rectScreen2.right += nValue;

					if ( SWOT_RegReadInteger( HKEY_CURRENT_USER, strMonitorRect, SWOT_REG_VAR__CY, 0, &nValue ) == ERROR_SUCCESS )
					{
						rectScreen2.bottom += nValue;
						bFound = TRUE;
					}
				}
			}
		}
	}

	//------------------------------------------------

	if ( !bFound )	//	Memory error or at least one key or variable not found?
	{
		rectScreen2.left = rectScreen2.top = rectScreen2.right = rectScreen2.bottom = 0;
	}

//---------------------------------------------------------------------------------------------------

	bUnalteredValuesFromReg = bFound;

	//	The saved application window position may become invalid if the monitor has been moved
	//	 or if the monitor no more exists.  When this happens the saved position is ignored and
	//	 the window rectangle is set to the specified default.
	if ( rectScreen1 != rectScreen2 )
	{
		rectScreen1 = rcrectScreenDefault;
		bUnalteredValuesFromReg = FALSE;
	}

	if ( cbCenterInWorkArea )
	{
		rectScreen2 = rectScreen1;

		rectScreen1.left   = (rectWorkArea.left + ((rectWorkArea.Width()  - rectScreen2.Width() ) / 2));
		rectScreen1.top	 = (rectWorkArea.top  + ((rectWorkArea.Height() - rectScreen2.Height()) / 2));
		rectScreen1.right  = (rectScreen1.left + rectScreen2.Width());
		rectScreen1.bottom = (rectScreen1.top  + rectScreen2.Height());

		if ( rectScreen1 != rectScreen2 ) bUnalteredValuesFromReg = FALSE;
	}

	//------------------------------------------------

	if ( cbAlignToWorkAreaEdges )
	{
		if ( rectScreen1.right > rectWorkArea.right )	//	Align to right?
		{
			rectScreen1.left  = (rectWorkArea.right - rectScreen1.Width() );
			rectScreen1.right = rectWorkArea.right;
			bUnalteredValuesFromReg = FALSE;
		}

		if ( rectScreen1.bottom > rectWorkArea.bottom )	//	Align to bottom?
		{
			rectScreen1.top    = (rectWorkArea.bottom - rectScreen1.Height());
			rectScreen1.bottom = rectWorkArea.bottom;
			bUnalteredValuesFromReg = FALSE;
		}

		if ( rectScreen1.left < rectWorkArea.left )	//	Align to left?
		{
			rectScreen1.right = (rectWorkArea.left + rectScreen1.Width());
			rectScreen1.left  = rectWorkArea.left;
			bUnalteredValuesFromReg = FALSE;
		}

		if ( rectScreen1.top < rectWorkArea.top )	//	Align to top?
		{
			rectScreen1.bottom = (rectWorkArea.top + rectScreen1.Height());
			rectScreen1.top    = rectWorkArea.top;
			bUnalteredValuesFromReg = FALSE;
		}
	}

//---------------------------------------------------------------------------------------------------

	if ( prectScreen	 != 0 ) *(prectScreen  ) = rectScreen1;
	if ( prectWorkArea != 0 ) *(prectWorkArea) = rectWorkArea;
	if ( prectMonitor  != 0 ) *(prectMonitor ) = rectMonitor;

//---------------------------------------------------------------------------------------------------

	return( bUnalteredValuesFromReg );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2008-09-10  Modified: 2016-07-12	//
//																																	//
//	Purpose:																														//
//																																	//
//	'pcszScreenRegKeyName': Example: "Software\Adeluc\Three Timers V2\MainWindow".						//
//																																	//
//	'hwndScreen': Must be valid otherwise nothing will be saved.												//
//																																	//
//	'prectScreen': May be 0 if you do not need this information.  Will contain the values about		//
//						the current screen.																					//
//																																	//
//	'prectWorkArea': May be 0 if you do not need this information.  Will contain the values about	//
//						  the WorkArea of the target monitor.															//
//																																	//
//	'prectMonitor': May be 0 if you do not need this information.  Will contain the values about		//
//						 the target monitor.																					//
//																																	//
//	Result: Returns TRUE if successful.  Otherwise returns FALSE and fills requested rectangles		//
//		  with zero.  																											//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

bool SWOT_SaveScreenInfoToRegistry( LPCTSTR pcszScreenRegKeyName, HWND hwndScreen,
												CRect *prectScreen, CRect *prectWorkArea, CRect *prectMonitor )
{
	bool					bStatus = TRUE;
	CString				strMonitorRect, strTmp;
	CRect					rectScreen, rectMonitor, rectWorkArea;
	WINDOWPLACEMENT	wndpl;
		  				
	wndpl.length = sizeof( WINDOWPLACEMENT );

//---------------------------------------------------------------------------------------------------

	if ( ::IsWindow( hwndScreen ) )
	{
		GetWindowPlacement( hwndScreen, &wndpl );		//	Always returns TRUE if you provide correct parameters.
		rectScreen = wndpl.rcNormalPosition;			// Rectangle is relative to Monitor's WorkArea.

		//	Does not matter if 'rectScreen' is in Monitor or WorkArea coordinates.
		SWOT_GetMonitorAndWorkAreaInfoFromRect( rectScreen, &rectWorkArea, &rectMonitor );

		if ( ((GetWindowLongPtr( hwndScreen, GWL_STYLE ) & WS_CHILD) == 0) &&
			  ((GetWindowLongPtr( hwndScreen, GWL_EXSTYLE ) & WS_EX_TOOLWINDOW) == 0) )
		{
			//	Make rectangle relative to monitor.
			rectScreen.OffsetRect( (rectWorkArea.left - rectMonitor.left), (rectWorkArea.top - rectMonitor.top) );
		}

		//------------------------------------------------

		strTmp.Format( SWOT_REG_KEY__MonitorRectangle, rectMonitor.left, rectMonitor.top, rectMonitor.right, rectMonitor.bottom );
		strMonitorRect.Format( _T("%s\\%s"), pcszScreenRegKeyName, (LPCTSTR)strTmp );

		SWOT_RegWriteInteger( HKEY_CURRENT_USER, pcszScreenRegKeyName, SWOT_REG_VAR__X , rectScreen.left		 );
		SWOT_RegWriteInteger( HKEY_CURRENT_USER, pcszScreenRegKeyName, SWOT_REG_VAR__Y , rectScreen.top		 );
		SWOT_RegWriteInteger( HKEY_CURRENT_USER, pcszScreenRegKeyName, SWOT_REG_VAR__CX, rectScreen.Width()  );
		SWOT_RegWriteInteger( HKEY_CURRENT_USER, pcszScreenRegKeyName, SWOT_REG_VAR__CY, rectScreen.Height() );

		SWOT_RegWriteInteger( HKEY_CURRENT_USER, strMonitorRect, SWOT_REG_VAR__X , rectScreen.left		 );
		SWOT_RegWriteInteger( HKEY_CURRENT_USER, strMonitorRect, SWOT_REG_VAR__Y , rectScreen.top		 );
		SWOT_RegWriteInteger( HKEY_CURRENT_USER, strMonitorRect, SWOT_REG_VAR__CX, rectScreen.Width()  );
		SWOT_RegWriteInteger( HKEY_CURRENT_USER, strMonitorRect, SWOT_REG_VAR__CY, rectScreen.Height() );

		//------------------------------------------------

		if ( prectScreen	 != 0 ) *(prectScreen  ) = rectScreen;
		if ( prectWorkArea != 0 ) *(prectWorkArea) = rectWorkArea;
		if ( prectMonitor  != 0 ) *(prectMonitor ) = rectMonitor;
	}

//---------------------------------------------------------------------------------------------------

	else
	{
		bStatus = FALSE;

		if ( prectScreen	 != 0 ) prectScreen->SetRectEmpty();
		if ( prectWorkArea != 0 ) prectWorkArea->SetRectEmpty();
		if ( prectMonitor  != 0 ) prectMonitor->SetRectEmpty();
	}

//---------------------------------------------------------------------------------------------------

	return( bStatus );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2013-08-31  Modified: 2016-07-11	//
//																																	//
//	Purpose:	Creates a 32-bit bitmap, initializes it with the 'cpixCanvasColor' background color,	//
//				then blends the 'hiconSource' icon onto it.															//
//																																	//
//	IMPORTANT: Monochrome icons are not supported and only 32-bit icons are supported.					//
//																																	//
// Future improvement: To eventually implements support for transparency with 24-bit, 8-bit or   	//
//							  4-bit icons, see the DT_CreateDisabledIcon() function.								//
//																																	//
//	'hiconSource':	Must be a 32-bit icon otherwise its transparency will be ignored.						//
//																																	//
// 'cpixCanvasColor': Be sure to set its alpha component to 'JCH_PIXEL_CHANNEL_MAX_VAL' otherwise	//
//							 the resulting bitmap will contain transparency.										//
//																																	//
//	Result: Returns 0 only if an error occurred.  Otherwise returns the created bitmap handle.		//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

HBITMAP SWOT_Create32BitsBitmapFrom32BitsIcon( HICON hiconSource, const JCH_Pixel cpixCanvasColor )
{
	HBITMAP			hbitmapCanvas = 0;
	HDC				hdcBitmap	  = 0;
	ICONINFO			iiSource;
	BITMAP			bmSource;
	BITMAPINFO		bmiSource;
	JCH_PixelMap	pixmapSource, pixmapCanvas;

//---------------------------------------------------------------------------------------------------

	if ( ::GetIconInfo( hiconSource, &iiSource ) != 0 )
	{
		if ( ::GetObject( iiSource.hbmColor, sizeof( BITMAP ), &bmSource ) != 0 )
		{
			if ( (hdcBitmap = ::CreateCompatibleDC( 0 )) != 0 )
			{
				if ( pixmapSource.AllocatePixels( bmSource.bmWidth, bmSource.bmHeight ) &&
					  pixmapCanvas.AllocatePixels( bmSource.bmWidth, bmSource.bmHeight, TRUE, cpixCanvasColor ) )
				{
					bmiSource = *(pixmapSource.GetBitMapInfoAddress());		//	Required because GetDIBits() may modify 'bmiSource'.

					if ( ::GetDIBits( hdcBitmap, iiSource.hbmColor, 0, bmSource.bmHeight,
							pixmapSource.GetFirstPixelAddress(), &bmiSource, DIB_RGB_COLORS ) == bmSource.bmHeight )
					{
						pixmapSource.AlphaBlend( 0, 0, 0, 0, bmSource.bmWidth, bmSource.bmHeight, pixmapCanvas );

						if ( (hbitmapCanvas = CreateBitmap( bmSource.bmWidth, bmSource.bmHeight, 1, 32, 0 )) != 0 )
						{
							if ( !::GdiFlush() || (::SetDIBits( hdcBitmap, hbitmapCanvas, 0, bmSource.bmHeight, pixmapCanvas.GetFirstPixelAddress(), 
									pixmapCanvas.GetBitMapInfoAddress(), DIB_RGB_COLORS ) != bmSource.bmHeight) )
							{
								::DeleteObject( hbitmapCanvas );
								hbitmapCanvas = 0;
							}
						}
					}
				}

				::DeleteDC( hdcBitmap );
				hdcBitmap = 0;
			}
		}

		if ( iiSource.hbmColor != 0 ) ::DeleteObject( iiSource.hbmColor );
		if ( iiSource.hbmMask  != 0 ) ::DeleteObject( iiSource.hbmMask  );
	}

//---------------------------------------------------------------------------------------------------

	return( hbitmapCanvas );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2001-05-12  Modified: 2016-07-11	//
//																																	//
//	Purpose:	Create the specified folder and its parent folders if they do not already exist.			//
//																																	//
//	Note: If the specified folder	already exists, nothing is done and TRUE is returned.					//
//																																	//
//	Result: If the function succeeds, return is TRUE, oherwise return is FALSE.							//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

bool SWOT_CreateFolder( LPCTSTR pcszFolderPath, LPSECURITY_ATTRIBUTES lpSecurityAttributes )
{
	int		nIndex;
	int		nRecursiveCount = 1;
	TCHAR		szFolderPath[MAX_PATH];
	
//---------------------------------------------------------------------------------------------------

	if ( (pcszFolderPath == 0) || _tcsIsEmpty( pcszFolderPath ) || (_tcslen( pcszFolderPath ) >= _countof( szFolderPath )) ) return( FALSE );

	if ( ::PathFileExists( pcszFolderPath ) != 0 )
	{
		if ( ::PathIsDirectory( pcszFolderPath ) != 0 ) return( TRUE  );	// A folder aleady exists?
		else															return( FALSE );	// A file aleady exists?
	}

	_tcscpy_s( szFolderPath, pcszFolderPath );

//

	FOREVER
	{
		if ( ::CreateDirectory( szFolderPath, lpSecurityAttributes ) != 0 ) nRecursiveCount--;	// Successful?
		else																					  nRecursiveCount++;

		if ( nRecursiveCount == 0 ) break;

//

		_tcscpy_s( szFolderPath, pcszFolderPath );

		for( nIndex = 1; nIndex < nRecursiveCount; nIndex++ )
		{
			if ( ::PathRemoveFileSpec( szFolderPath ) == 0 ) break;			// Nothing removed from string?
		}

		if ( nIndex < nRecursiveCount ) break;										// Error occurs in previous loop?

		if ( _tcsIsEmpty( szFolderPath ) ) break;
	}

//---------------------------------------------------------------------------------------------------

	return( ((nRecursiveCount == 0) ? TRUE : FALSE) );
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2010-05-24  Modified: 2016-09-08	//
//																																	//
//	Purpose:	Whatever if an extension is present or not in 'pszPath', the 'pcszExt' will be always 	//
//				appended to 'pszPath' if enough space is available.												//
//																																	//
//	Note: This function has been created essentially to replace the unreliable 'PathAddExtension()'	//
//			function that will not add the 'pcszExt' if a dot is already present in 'pszPath'.			//
//																																	//
//	Note: The contents of 'pcszExt' must begin with a '.' character otherwise the appended string	//
//			will not be separated by a '.' character.																	//
//																																	//
//	Result: Returns TRUE if successful.  Otherwise returns FALSE.												//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

bool SWOT_PathAppendExtension( LPTSTR pszPath, LPCTSTR pcszExt )
{
	size_t	sztStrLenPath = _tcslen( pszPath );
	bool		bStatus;

	if ( (sztStrLenPath + _tcslen( pcszExt )) < MAX_PATH )
	{
		_tcscpy( &pszPath[sztStrLenPath], pcszExt );
		bStatus = TRUE;
	}
	else bStatus = FALSE;

	return( bStatus );
}


