/////////////////////////////////////////////////////////////////////////////////////////////////////
//																																	//
//	Coded by www.decotechpro.com, all rights reserved.  Created: 2016-07-07  Modified: 2016-09-08	//
//																																	//
// SetWndOnTop.h : Main header of the "Set Window On Top" application.										//
//																																	//
/////////////////////////////////////////////////////////////////////////////////////////////////////

//#include "SetWndOnTop.h"
#pragma once

#include "resource.h"

#if defined( _DT_LANG_0 )		//	French language?
	#include "SetWndOnTop_fr.h"
#elif defined( _DT_LANG_1 )	//	English language?
	#include "SetWndOnTop_en.h"
#else
#error	_DT_LANG_?
#endif

#include "SWOT_Pixel.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////
//	Instruction to build the ENGLISH application:
//	1- In "Configuration Properties" --> "C++" -->  "Preprocessor" --> "Preprocessor Definitions": Rename _DT_LANG_# to _DT_LANG_1.
//	2- In "Configuration Properties" --> "Resources" --> "General" --> "Preprocessor Definitions": Rename _DT_LANG_# to _DT_LANG_1.
//	3- Save all then compile.
//---------------------------------------------------------------------------------------------------
//	Instruction to build the FRENCH application:
//	1- In "Configuration Properties" --> "C++" -->  "Preprocessor" --> "Preprocessor Definitions": Rename _DT_LANG_# to _DT_LANG_0.
//	2- In "Configuration Properties" --> "Resources" --> "General" --> "Preprocessor Definitions": Rename _DT_LANG_# to _DT_LANG_0.
//	3- Save all then compile.
//	4- Rename "SetWndOnTop.exe" to "MettreFenAuDessus.exe". (Note: Do not rename if built for the "DecoTech Pro\bin_v7" folder.)
/////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////

#define	SWOT_FONT_NAME__Segoe_UI			_T("Segoe UI")
#define	SWOT_FONT_FILE_SEGOEUI_TTF			_T("SegoeUI.ttf")

#define  SWOT_EXTENSION__lnk					_T(".lnk")

//---------------------------------------------------------------------------------------------------

extern	bool	SWOT_InitInstance( HINSTANCE hInstanceApp, LPTSTR pszCmdLine, int nCmdShow );
extern	void	SWOT_ExitInstance();

/////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////

#define	SWOT_REG_KEY__ADELUC					_T("Software\\Adeluc")
#define	SWOT_REG_KEY__ADELUC_SWOTn			SWOT_REG_KEY__ADELUC _T("\\Set Window On Top V%u")		//	Used to create 'm_strRegKey__AppKeyName'. 

#define	SWOT_REG_KEY__MainWindow			_T("MainWindow")
#define	SWOT_REG_KEY__MonitorRectangle	_T("MonitorRectangle(%ld,%ld,%ld,%ld)")

#define 	SWOT_REG_VAR__X						_T("X")
#define 	SWOT_REG_VAR__Y						_T("Y")
#define 	SWOT_REG_VAR__CX						_T("CX")
#define 	SWOT_REG_VAR__CY						_T("CY")

//------------------------------------------------

#define 	SWOT_REG_VAR__KeepDialogOnTop		_T("KeepDialogOnTop")
#define 	SWOT_REG_VAR__AutoFindRootParent	_T("AutoFindRootParent")
#define 	SWOT_REG_VAR__DrawInvertedFrame	_T("DrawInvertedFrame")

//---------------------------------------------------------------------------------------------------

extern long SWOT_RegWriteInteger( HKEY hRootKey, const char *pcszKey, const char *pcszValueName, const int cnValue );
extern long SWOT_RegReadInteger( HKEY hRootKey, const char *pcszKey, const char *pcszValueName, const int cnDefaultValue, int *pnValue );

extern DWORD SWOT_RegTestKey( HKEY hRootKey, const char *pcszKey, int *pnSubKeyCount = 0,
										int *pnDefaultValueCount = 0, int *pnNonDefaultValueCount = 0 );

extern void SWOT_LoadMiscSettingsFromRegistry( bool *pbIsKeepDlgOnTop = NULL, bool *pbIsAutoFindRootParent = NULL,
															  bool *pbIsDrawInvertedFrame = NULL );
extern int SWOT_SaveMiscSettingsToRegistry( const bool cbIsKeepDlgOnTop, const bool cbIsAutoFindRootParent,
														  const bool cbIsDrawInvertedFrame );

/////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////

#define	SWOT_MINSTRBUF__VERSION		(5+1+5+1+5+1+5+EOS_CHAR_COUNT)	

extern bool SWOT_SHGetVersionNumbers( LPCTSTR pcszFileName, unsigned __int64 *pun64FileVersion = 0, LPTSTR pszFileVersion = 0,
												  unsigned __int64 *pun64ProductVersion = 0, LPTSTR pszProductVersion = 0 );

inline unsigned short SWOT_SHGetVersionMajor(	 const unsigned __int64 cun64Version ) { return( HIWORD( cun64Version >> 32 ) ); }
inline unsigned short SWOT_SHGetVersionMinor(	 const unsigned __int64 cun64Version ) { return( LOWORD( cun64Version >> 32 ) ); }
inline unsigned short SWOT_SHGetVersionBuild(	 const unsigned __int64 cun64Version ) { return( HIWORD( cun64Version		  ) ); }
inline unsigned short SWOT_SHGetVersionRevision( const unsigned __int64 cun64Version ) { return( LOWORD( cun64Version		  ) ); }

inline void SWOT_SHCreateVersionNumber( LPTSTR pcszVersion, const unsigned __int64 cun64Version )
{	//	Buffer pointed by 'pcszVersion' must contain enough space for 'SWOT_MINSTRBUF__VERSION' characters, NULL character included.
	_stprintf( pcszVersion, _T("%hu.%hu.%hu.%hu"), SWOT_SHGetVersionMajor( cun64Version ), SWOT_SHGetVersionMinor( cun64Version ),
																  SWOT_SHGetVersionBuild( cun64Version ), SWOT_SHGetVersionRevision( cun64Version ) );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////

extern bool				SWOT_GetMonitorAndWorkAreaInfoFromRect( const CRect & rcrectWindow, CRect *prectWorkArea = 0,
																				 CRect *prectMonitor = 0, LPMONITORINFOEX pMonitorInfoEx = 0,
																				 const DWORD cdwFlags = MONITOR_DEFAULTTONEAREST );

extern void				SWOT_CenterWindow( HWND hwndChild, HWND hwndParent );
extern CString			SWOT_GetWindowText( HWND hwnd );

extern bool				SWOT_LoadScreenInfoFromRegistry( LPCTSTR pcszScreenRegKeyName, const CRect & rcrectScreenDefault,
														CRect *prectScreen = 0, CRect *prectWorkArea = 0, CRect *prectMonitor = 0,
														const bool cbCenterInWorkArea = FALSE, const bool cbAlignToWorkAreaEdges = TRUE );

extern bool				SWOT_SaveScreenInfoToRegistry( LPCTSTR pcszScreenRegKeyName, HWND hwndScreen, CRect *prectScreen = 0,
																	 CRect *prectWorkArea = 0, CRect *prectMonitor = 0 );

extern HBITMAP			SWOT_Create32BitsBitmapFrom32BitsIcon( HICON hiconSource, const JCH_Pixel cpixCanvasColor );
extern bool				SWOT_CreateFolder( LPCTSTR pcszFolderPath, LPSECURITY_ATTRIBUTES lpSecurityAttributes = 0 );
extern bool				SWOT_PathAppendExtension( LPTSTR pszPath, LPCTSTR pcszExt );

/////////////////////////////////////////////////////////////////////////////////////////////////////
